/******************************************************
 * CORDOVA
 */
var device_platform = null;
var aPushItem = JSON.parse(localStorage.getItem("BilbobusPush")) || [];
var fcmToken = "";

// Cordova initialization
document.addEventListener("deviceready", onDeviceReadyCordova, false);


//Cordova is loaded and it is now safe to call Cordova methods
//
function onDeviceReadyCordova() 
{
  // Register the event listener
  document.addEventListener("backbutton", onBackKeyDown, false);
  gb_isCordovaLoaded = true;
  headerIsHidded = false;

  model = device.model;
  platform = device.platform;
  deviceID = device.uuid;
  deviceVersion = device.version;
  device_platform = platform.toUpperCase();


  app_version = AppVersion.version;
  window.open = cordova.InAppBrowser.open;
  
  setTimeout(function() {
    navigator.splashscreen.hide();
  }, 2000);

  functionsGlobals.getLocation();
  
  FCMPlugin.getToken(saveToken,tokenError);

  FCMPlugin.onTokenRefresh(saveToken,tokenError);

  FCMPlugin.onNotification(function(data) {
    
    console.log("Notification", data);
    if(data.wasTapped) {
      console.log("Notification: Tapped");
      //Notification was received on device tray and tapped by the user.
      onLaunchedFromPush(data);
    }
    else {
      console.log("Notification: NO Tapped");
      //Notification was received in foreground. Maybe the user needs to be notified.
      onPushReceived(data);
    }
  });
}

// Registration callbacks
function saveToken(token) {
  fcmToken = token;
  console.info("TOKEN", token);
}

function tokenError(error) {
  console.error(error);
}

// Incoming message callback
function onPushReceived(data) 
{
    //console.log(data);
    
    if(data.line == undefined)
      return false;

      var aPushItem = JSON.parse(localStorage.getItem("BilbobusPush")) || [];
      var NotificationPush = data;  

      fecha = new Date();
      var month = fecha.getMonth()+1;
      var day = fecha.getDate();
      var output = fecha.getFullYear() + '-' +
          (month<10 ? '0' : '') + month + '-' +
          (day<10 ? '0' : '') + day;

 
      var push_id = data.notification_id;
      var push_message = data.message;

      $(".open_incomming_push").attr("href","pushNews2.html?line="+NotificationPush.line+"&push_id="+push_id);
      $('.popup_push').popup("open");


      if (aPushItem.length > 0) {

        $.each(aPushItem, function(i, item) {

          if (item.push_id != push_id) {
            aPushItem.push({
              push_id: push_id,
              alert: push_message,
              linea: NotificationPush.line,
              fecha_id: fecha,
              fecha: functionsGlobals.getDateFormatted(output),
              hora: functionsGlobals.UTCDateFormat(fecha),
            }); 
          }

        });  

      } 
      else { 

       aPushItem.push({
          push_id: push_id,
          alert: push_message,
          linea: NotificationPush.line,
          fecha_id: fecha,
          fecha: functionsGlobals.getDateFormatted(output),
          hora: functionsGlobals.UTCDateFormat(fecha)
        }); 
       
      }
                

      for( var i = 0; i < aPushItem.length; i++){
        for( var x = i+1; x < aPushItem.length; x++){
          if( aPushItem[x].push_id == aPushItem[i].push_id){
            aPushItem.splice(x,1);
            --x;
          }
        }
      }

      localStorage.setItem("BilbobusPush", JSON.stringify(aPushItem));

      $(".pending_notifications").text(aPushItem.length);
      $(".pending_notifications").show();
          
}

// Incoming message callback
function onLaunchedFromPush(data) 
{
  if(!$.isEmptyObject(data))
  {
    if(data.line == undefined)
      return false;

    var push_id = data.notification_id;

    $( "body" ).pagecontainer( "change", "pushNews2.html?line="+data.line+"&push_id="+push_id);
  }
}

/**
* Función para que al pustar atras en una pantalla de la navbar, se quite la aplicación (Phonegap)
*/
function onBackKeyDown()
{
  

  if( !$( "body" ).hasClass( "ui-disabled" ))
  {

  if ( $(".ui-popup-active")[0] )
  {
    $(".ui-popup").popup("close");
    return false;
  } else if( $.mobile.activePage.is( ".exitapp" ) ) 
    {
      navigator.notification.confirm(
        gjson_lang['exit_msg'], // message
        onConfirm, // callback to invoke with index of button pressed
        gjson_lang['exit_title'], // title
        [gjson_lang['exit_ok'],gjson_lang['exit_cancel']] // buttonLabels
      );
    } 
    else if( $.mobile.activePage.is( ".goToMain" ) ) 
    {
      $( "body" ).pagecontainer( "change", "lines.html" );
      return false;
    }
    else if( $.mobile.activePage.is( ".StopStimes" ) ) 
    {
      if (!sessionStorage.getItem("back_StopTimes") || sessionStorage.getItem("back_StopTimes") == 'undefined')
      {
        $( "body" ).pagecontainer( "change", "lines.html");
      }
      else
      {
        $( "body" ).pagecontainer( "change", sessionStorage.getItem("back_StopTimes"));
      }
        

      sessionStorage.removeItem("back_StopTimes");
      return false;
    }
    else if( $.mobile.activePage.is( ".goToLines" ) ) 
    {
      if (sessionStorage.getItem("actual_StopTimes") && sessionStorage.getItem("back_complete"))
      {
        navigator.app.backHistory();
      }
      else if (sessionStorage.getItem("back_favorite"))
      {
        $( "body" ).pagecontainer( "change", "favorites_lineas.html");   
      }
      else
        $( "body" ).pagecontainer( "change", "lines.html");

      return false;
    }
    else if( $.mobile.activePage.is( ".page_pushNews2" ) ) 
    {
      $("#back_btn_push").click();
      return false;
    }
    else if($.mobile.activePage.is(".goToSuggestions"))
    {
      $("#back_btn_select_stop").click();
      return false;
    }
    else 
    {
      navigator.app.backHistory();
      return false;
    }
  }
  
  return false;
}

function onKeyboardShow()
{
  $.mobile.activePage.find("div[data-role='footer']").hide();
}

function onKeyboardHide()
{
  $('input, textarea').blur(); 
  $.mobile.activePage.find("div[data-role='footer']").show();
}

function onConfirm( index )
{
  if ( index === 1 ){
    navigator.app.exitApp();
  }
}
/**
* Function to check the state of Internet connection
*/
function checkConnection() {
  if(isCordovaEnvironment())
  {

     var networkState = navigator.network.connection.type;
         
     var states = {};
     states[Connection.UNKNOWN]  = 0;
     states[Connection.ETHERNET] = 1;
     states[Connection.WIFI]     = 2;
     states[Connection.CELL_2G]  = 3;
     states[Connection.CELL_3G]  = 4;
     states[Connection.CELL_4G]  = 5;
     states[Connection.NONE]     = 6;   

     if(states[networkState] == 6)
     {
        return false;
     }
     else
     {
      return true;
     }
      
  }else
    return true;

}

function isCordovaEnvironment() {
  var app = document.URL.indexOf( 'http://' ) === -1 && document.URL.indexOf( 'https://' ) === -1;
  return app;
}

