/* CSS */
$("body").append('<link rel="stylesheet" type="text/css" href="css/pageApps.css"/>');

/* VARIABLES */
var pageApps = {

    $page: null,

    init: function() {
        pageApps.addContent();
        pageApps.getData();

    },

    addContent: function() {
        pageApps.$page.find("#page_title").text(gjson_lang['page_title_apps']);
    },

    getData: function() {
        functionsGlobals.showLoading();

        connection.getResponse(aConfig["URL_JSON_APPS"], "json")
            .done(function(data_response) {
                // check Json apps to discard THIS app
                console.warn(data_response);
                pageApps.checkAppList(data_response);
                functionsGlobals.hideLoading();
            });
    },

    showData: function(data) {
        var a_block_class = ["a", "b"];

        $.each(data.apps, function(i, item) {
            var block_class = "ui-block-" + a_block_class[i % 2];
            if ((navigator.userAgent.match(/iPhone/i)))
                var store = item.url_ios;
            else if (navigator.userAgent.match(/Android/i))
                var store = item.url_android;
            else
                var store = "#";

            $('#apps').append("<div class=" + block_class + "><a href=" + store + "><div class ='app_content'><img src=" + item.image + "><h1><b>" + item.name + "</b></h1><p>" + eval("item.text_" + language) + "</p></div></div></div>");
        });

        //pageApps.$page.find("#about_app_version").text(gjson_lang.version+" "+app_version);
    },


    checkAppList: function(otherAppsList) {
        for (var i = 0; i < otherAppsList.apps.length; i++) {
            if (otherAppsList.apps[i].app_identifier == aConfig['APP_IDENTIFIER']) {
                otherAppsList.apps.splice(i, 1);
            }
        }
        pageApps.showData(otherAppsList);
    }

};

/* EVENTS */

$(document).off(".apps")

.on("pagecreate.apps", "#page_apps", function() {
    pageApps.$page = $(this);
})

.on("pageshow.apps", "#page_apps", function() {
    pageApps.init();

})

.on("pageremove.apps", "#page_apps", function() {
    $(window).off(".apps");
    $(document).off(".apps");
    $('link[href="css/pageApps.css"]').remove();
    pageApps = null;
});