/* CSS */
$( "body" ).append('<link rel="stylesheet" type="text/css" href="css/pageHelp.css"/>');

/* VARIABLES */
var posicion_slide = 1;
var help_slides = 5; 

var pageHelp = {
		
	$page : null,
	$active_slide: 1,

	init: function() 
	{
		for (var i = 0; i < help_slides; i++) {
			var id_bullet = i+1;
			if(id_bullet != 4)
					$("#bullets").append('<div id = "bullet_'+id_bullet+'" class ="bullet"></div>');

				
		}

		pageHelp.addContent();

	},

	addContent : function() 
	{
		pageHelp.$page.find("#page_title").text(gjson_lang['page_title_help']);
		pageHelp.displayButtons();
		pageHelp.updateBullets();
		pageHelp.showData();
	},

	showData : function() 
	{

		if (posicion_slide == 4)
			posicion_slide = 5;

		$(".help_container_image").css("background", "url('img/help/help_"+posicion_slide+"_"+language+".png')");
		$(".help_title").text(gjson_lang['help_'+posicion_slide+'_title']);
		$(".help_description").text(gjson_lang['help_'+posicion_slide+'_description']);

		
	},

	showSlide : function() 
	{
		if (posicion_slide == 4)
			posicion_slide = 5;
		
		pageHelp.displayButtons();
		pageHelp.updateBullets();
		$(".content_slides").hide();
		$(".help_container_image").css("background", "url('img/help/help_"+posicion_slide+"_"+language+".png')");
		$(".help_title").text(gjson_lang['help_'+posicion_slide+'_title']);
		$(".help_description").text(gjson_lang['help_'+posicion_slide+'_description']);
		$(".content_slides").fadeIn(300);
		$(".content_slides").css("left",0);		

	},

	displayButtons : function() 
	{
	  if (posicion_slide > 1)
	    $(".btn_prev").css("display", "block");
	  else
	    $(".btn_prev").css("display", "none");

	  if (posicion_slide < help_slides - 1)
	    $(".btn_next").css("display", "block");  
	  else
	    $(".btn_next").css("display", "none"); 
	},

	updateBullets : function() 
	{
		$(".bullet").removeClass("bullet_active");
		$("#bullet_"+posicion_slide).addClass("bullet_active");
	}	



};

/* EVENTS */

$( document ).off(".help")

	.on("pagecreate.help", "#page_help", function()
	{
		pageHelp.$page = $(this);
	})

	.on("pageshow.help", "#page_help", function()
	{
		pageHelp.init();

       $( this ).swipe( {

        swipeStatus: function( event, phase, direction, distance, duration, fingers )
        {
              if ( phase == "move")
              {         
                    if ( direction == "right")
                    {
                      $(".content_slides").css("left", distance);
                      
                      if( distance >= $(".content_slides").width()/3 && posicion_slide > 1)
                      {
                          $(".content_slides")
                          .stop()
                          .animate(
                            { "left": $(".content_slides").width() }, 
                            { duration: 500, queue: false, done: function(){

                              $(".btn_prev").click();
                            }}
                          );
                      }
                      else
                      {
                        $(".content_slides")
                        .stop()
                        .animate(
                          { "left": 0 }, 
                          { duration: 500, queue: false } 
                        );
                      }
                    }else
                    if (direction == "left" )
                    {

                      $(".content_slides").css("left", distance*-1);

                      if( distance >= $(".content_slides").width()/3 && posicion_slide < help_slides) 
                      {
                          $(".content_slides")
                          .stop()
                          .animate(
                            { "left": $(".content_slides").width()*-1 }, 
                            { duration: 500, queue: false, done: function(){
                              $(".btn_next").click();
                            }}
                          );
                      }
                      else
                      {
                        $(".content_slides")
                        .stop()
                        .animate(
                          { "left": 0 }, 
                          { duration: 500, queue: false } 
                        );
                      }
                    }
              }
              else if ( phase == "cancel" )
              {
                  $(".content_slides")
                  .stop()
                  .animate(
                    { "left": 0 }, 
                    { duration: 500, queue: false } 
                  );
              }
        },   

        })

	})

	.on("click.slides", ".btn_next", function(event)
	{
	  event.preventDefault();
	  posicion_slide++;
	  pageHelp.showSlide();
	  return false;
	})  

	.on("click.slides", ".btn_prev", function(event)
	{
	  event.preventDefault();
	  posicion_slide--;
	  pageHelp.showSlide();
	  return false;
	})  

	.on("pageremove.help", "#page_help", function()
	{
		$( window ).off( ".help" );
		$( document ).off(".help");
		$( 'link[href="css/pageHelp.css"]' ).remove();
		pageHelp = null;
		$( this ).swipe('destroy');
	});

