/* CSS */
$( "body" ).append('<link rel="stylesheet" type="text/css" href="css/pageLanguage.css"/>');

/* VARIABLES */
var pageLanguage = {
		
	$page : null,

	init: function() 
	{
		
		pageLanguage.addContent();

	},

	addContent : function() 
	{
		pageLanguage.$page.find("#page_title").text(gjson_lang['page_title_language']);
	},

	changeLanguageOfTagNotifications: function(old_language, new_language)
	{
		console.log(gb_isCordovaLoaded);
		if(gb_isCordovaLoaded)
		{
			functionsGlobals.getLocalNotificationTags( function(tags)
			{
				functionsGlobals.deleteAllNotificationTags( function()
				{
					tags.forEach( function(current_tag)
					{
						var new_tag = current_tag.replace(old_language+"_", new_language+"_");
						functionsGlobals.addLocalNotificationTag(new_tag, void(0));
					});
				});
				
			});
		}
	}


};

/* EVENTS */

$( document ).off(".language")

	.on("pagecreate.language", "#page_language", function()
	{
		pageLanguage.$page = $(this);
	})
	
	.on("pageshow.language", "#page_language", function()
	{
		pageLanguage.init();
	})

	.on("click.language", "#page_language .btn_language", function(event)
	{
		event.preventDefault();

		var old_language = localStorage.getItem("language");
		var new_language = $(this).attr("data-lang");

		localStorage.setItem("language", new_language);
		pageLanguage.changeLanguageOfTagNotifications(old_language, new_language);

		window.location="index.html";
		return false;
	})

	.on("pageremove.language", "#page_language", function()
	{
		$( window ).off( ".language" );
		$( document ).off(".language");
		$( 'link[href="css/pageLanguage.css"]' ).remove();
		pageLanguage = null;
	});
