/* CSS */
$( "body" ).append('<link rel="stylesheet" type="text/css" href="css/pageLineNews.css"/>');

/* VARIABLES */
var pageLineNews = {
		
	$page : null,
	active_tab : 4,


	init: function() 
	{
		pageLineNews.getData(sessionStorage.getItem("direction"));
	},

	getData : function(direction) 
	{

		functionsGlobals.showLoading();

		pageLineNews.$page.find("#page_title").text(sessionStorage.getItem("codigoLineaActiva")+" - "+sessionStorage.getItem("name_linea"+direction));
    		
		if ( !checkConnection() )
		{
		    functionsGlobals.showMessage(gjson_lang['connectionError'], null);
		    return false;
		}

    	connection.getResponse(aConfig["URL_LINE_RSS_NEWS_"+language]+sessionStorage.getItem("codigoLineaActiva"), "xml")
        .done(function(data_response) {
                  pageLineNews.showData(data_response);
        });

	},

	showData : function(data) 
	{

		pageLineNews.$page.find("#page-line-news-list").empty();


		if ($(data).find(' channel item ').length == 0)
			functionsGlobals.showMessage(gjson_lang['no_datos'], null);
		else
		{
			$(data).find(' channel item ').each(function(i)
			{

				html = '<a data-rel = "external" href = "'+$(this).find('link').text()+'">'+
						'<li data-icon="false">'+ 
						'<p class = "news_date">'+ functionsGlobals.getDateFormatted($(this).find('pubDate').text()) + '</p>'+
						'<h1>'+ $(this).find('title').text() + '</h1>'+
						'<p>'+ $(this).find('description').text()+ '</p>'+
						'</li></a>';

						'</li></a>';		

				pageLineNews.$page.find("#page-line-news-list").append(html);

			});

			pageLineNews.$page.find('#page-line-news-list').listview('refresh');			
		}


		functionsGlobals.hideLoading();
	}

};

/* EVENTS */

$( document ).off(".lineNews")

	.on("pagecreate.lineNews", "#page_lineNews", function()
	{
		pageLineNews.$page = $(this);
	})

	.on("pageshow.lineNews", "#page_lineNews", function()
	{
		pageLineNews.init();

	})
	.on("click.lineNews", "#page_lineNews .footer_links", function(event)
	{
		event.preventDefault();
		if ($(this).attr("id") == 'footer_stops' ) $( "body" ).pagecontainer( "change", "stops.html?filter=" + sessionStorage.getItem("filter1")+"&filter2="+sessionStorage.getItem("filter2") );
		if ($(this).attr("id") == 'footer_route' ) $( "body" ).pagecontainer( "change", "travelMap.html?id=" + sessionStorage.getItem("direction")+"&name="+sessionStorage.getItem("name_linea"+sessionStorage.getItem("direction")));
		if ($(this).attr("id") == 'footer_schedule' ) $( "body" ).pagecontainer( "change", "schedule.html");	
		if ($(this).attr("id") == 'footer_lineNews' ) $( "body" ).pagecontainer( "change", "lineNews.html");	
		return false;	
	})
	.on("click.lineNews", "#page_lineNews #back_btn_lineNews", function(event)
	{
		event.preventDefault();

      	if (sessionStorage.getItem("actual_StopTimes") && sessionStorage.getItem("back_complete"))
      	{
      		window.history.back();
      	}
      		
     	else
     	{
     		$( "body" ).pagecontainer( "change", "lines.html");
     	}
        	

		return false;
	})
	.on("pageremove.lineNews", "#page_lineNews", function()
	{
		$( window ).off( ".lineNews" );
		$( document ).off(".lineNews");
		$( 'link[href="css/pageLineNews.css"]' ).remove();
		pageLineNews = null;
	});
