/* CSS */
$( "body" ).append('<link rel="stylesheet" type="text/css" href="css/pageLines.css"/>');

/* VARIABLES */
var pageLines = {
		
	$page : null,
	actual_line : 'regular',
	carga_lineas : false,
	searchbar_isvisible: false,

	init: function() 
	{
		pageLines.addContent();
		pageLines.getData();
	},

	addContent : function() 
	{
		pageLines.$page.find("#page_title").text(gjson_lang['page_title_lines_regular']);
		pageLines.$page.find("#myFilter").attr("placeholder",gjson_lang['search_line']);
	},

	getData : function() 
	{
    	functionsGlobals.showLoading();

		if( !localStorage.getItem("array_lineas") || !localStorage.getItem("array_paradas"))
		{
	       	sessionStorage.setItem("activeFunction", "pageLines.showLines()");
			CallServiceCAI(aConfig["gstr_webServiceURLCAI"], createSoapRequestgetStops(), "functionsGlobals.saveStops");
	        CallServiceCAI(aConfig["gstr_webServiceURLCAI"], SoapgetLines(), "pageLines.LoadLines");	        	
		}
		else
		{
			pageLines.showLines();
			functionsGlobals.hideLoading();
		}

	},

	LoadLines : function(data) 
	{

		var aLineas = [];

		if (data.numberOfFeatures == undefined)
		{
			functionsGlobals.showMessage(gjson_lang['error_ajax']);
			functionsGlobals.hideLoading();
			return false;
		}	
		
		$.each( data.featureMembers.Line, function( i, item ) 
		{
		
			if (item.routesForLine != undefined)
			{
				if(item.routesForLine[0].Route.direction.Direction.identity.DirectionCode.identifier == "IDA")
					aLineas.push({
						id_linea: item.identity.LineCode.identifier,
						name_linea: item.lineName,
						id_Route0: item.routesForLine[0].Route.identity.RouteCode.identifier,
						id_Route1: item.routesForLine[1].Route.identity.RouteCode.identifier
					});		
				else
					aLineas.push({
						id_linea: item.identity.LineCode.identifier,
						name_linea: item.lineName,
						id_Route0: item.routesForLine[1].Route.identity.RouteCode.identifier,
						id_Route1: item.routesForLine[0].Route.identity.RouteCode.identifier
					});					
			}
	
		});

		CallService(aConfig["gstr_webServiceURL"], createSoapRequestGetLineColors(), "pageLines.saveLineColors");	
		
		localStorage.setItem("array_lineas", JSON.stringify(aLineas));
	},

	saveLineColors : function(data) 
	{
//localStorage.setItem("array_lineas", JSON.stringify(aLineas));
//		pageLines.showLines();
		var aColors = [];

		$.each( data.LISTA.DETALLE, function( j, item ) 
		{
			aColors.push({
				id_linea: item.CODIGOLINEA,
				color: "#"+item.RGB
			});	
		});

		for( var i = 0; i < aColors.length; i++){
			for( var x = i+1; x < aColors.length; x++){
				if( aColors[x].id_linea == aColors[i].id_linea){
					aColors.splice(x,1);
					--x;
				}
			}
		}

		localStorage.setItem("colores_lineas", JSON.stringify(aColors));
		pageLines.showLines();
	},

	showLines : function() 
	{
		var html="";
		var data = JSON.parse(localStorage.getItem("array_lineas"));


		pageLines.$page.find("#lines_content").empty();

		data.sort(functionsGlobals.SortByLinea);
		
		$.each( data, function( i, item ) 
		{
			if ( pageLines.actual_line == "regular") cond = 'item.id_linea.indexOf("A") && item.id_linea.indexOf("G") && item.id_linea.indexOf("E")';
			if ( pageLines.actual_line == "auzolineas") cond = 'item.id_linea.indexOf("A") != -1';
			if ( pageLines.actual_line == "gautxori") cond = 'item.id_linea.indexOf("G") != -1';
			if ( pageLines.actual_line == "especiales") cond = 'item.id_linea.indexOf("E") != -1';
			
			if( eval(cond) )
			{

				html = '<li data-filtertext="'+item.name_linea+'">'+
					'<a href = "#" data-line= "'+item.id_linea+'" data-Route0="'+item.id_Route0+'" data-Route1="'+item.id_Route1+'">'+ 
					//'<div class="line_list_id line-color-div-'+item.id_linea+'">'+ item.id_linea + '</div>' + 
					'<div class="line_list_id" style="color:'+functionsGlobals.getColorLine(item.id_linea)+'">'+ item.id_linea + '</div>' + 
					'<div class="name_linea">'+ item.name_linea + '</div>'+
					'<div class = "div_favorite" id ="favorite'+i+'"></div>'+
					'<div class="listview_border"></div>'+
					'</li></a>';

				pageLines.$page.find("#lines_content").append(html);
			}			

			if (functionsGlobals.isFavoriteLine(item.id_linea))
				{
					pageLines.$page.find("#favorite"+i).append('<div class = "icon_favorite"><img src="img/stops/lista_favorito.png"></div>');
				}	
		});


		if(sessionStorage.getItem("lines_link"))
		{
			pageLines.actual_line = sessionStorage.getItem("lines_link");
			$('*[data-line="'+pageLines.actual_line+'"]').addClass("ui-btn-active");
			pageLines.$page.find("#page_title").text(gjson_lang['page_title_lines_'+pageLines.actual_line]);
			//sessionStorage.removeItem("lines_link");
		}

		pageLines.carga_lineas = true;
		pageLines.quitarLoading();

	},

	quitarLoading : function(data) 
	{		
		if(pageLines.carga_lineas && functionsGlobals.carga_paradas)
			functionsGlobals.hideLoading();
	}


};

/* EVENTS */

$( document ).off(".lines")

	.on("pagecreate.lines", "#page_lines", function()
	{
		functionsGlobals.deleteStops();
		pageLines.$page = $(this);
		
	})


	.on("pageshow.lines", "#page_lines", function()
	{
		pageLines.init();
		functionsGlobals.deleteSessionStorage();
	})
	
	.on("click.lines", "#page_lines .footer_links", function(event)
	{
		event.preventDefault();
		pageLines.$page.find(".footer_links").removeClass('ui-btn-active');
		$(this).addClass('ui-btn-active');
		sessionStorage.setItem("lines_link", $(this).attr('data-line'));
		pageLines.actual_line = $(this).attr('data-line');
		pageLines.$page.find("#page_title").text(gjson_lang['page_title_lines_'+$(this).attr('data-line')]);
		pageLines.showLines();
		return false;	
	})

	.on("click.lines", "#page_lines #lines_content a", function(event)
	{
		event.preventDefault();
		sessionStorage.setItem("codigoLineaActiva", $(this).attr('data-line'));
		
		var names = $(this).find(".name_linea").text().split('-');

		sessionStorage.setItem("name_linea", $.trim(names[0])+" - "+$.trim(names[1]));
		sessionStorage.setItem("name_linea"+$(this).attr("data-Route0"), $.trim(names[0])+" - "+$.trim(names[1]));
		sessionStorage.setItem("name_linea"+$(this).attr("data-Route1"), $.trim(names[1])+" - "+$.trim(names[0]));

		$( "body" ).pagecontainer( "change", "stops.html?filter=" + $(this).attr("data-Route0") +'&filter2=' + $(this).attr("data-Route1"));
		return false;	
	})

	.on("click.lines", "#page_lines #btn_filtro", function(event)
  	{
	   	event.preventDefault(); 
	    if(pageLines.$page.find(".div_search").is(":visible"))
	    {
			pageLines.$page.find(".div_search").hide();
			pageLines.$page.find(".ui-footer").show();
			$("#lines_content").css("padding-top", "0");

			if(device_platform == "IOS")
	    	{
		        $("#app_header").css("position", "fixed");
		        $(".div_search").css("position", "fixed");
	    	}

	      	$('#myFilter_lines').blur();
	    }
	    else
	    {
	    	// BUGFIX HEADER & KEYBOARD SHOWED
	    	if(device_platform == "IOS")
	        {
	            $("#app_header").css("position", "absolute");
	            $(".div_search").css("position", "absolute");
	        }


	      $(".ui-footer").hide();
	      pageLines.$page.find(".div_search").show();
	      $("#lines_content").css("padding-top", "4em");
	      $('#myFilter_lines').focus();

	      setTimeout(function(){
	        $(".ui-footer").show();
	      }, 1000);

	    }
	    return false;
  	})	

	.on("pageremove.lines", "#page_lines", function()
	{
		$( document ).off(".lines");
		$( 'link[href="css/pagelines.css"]' ).remove();
		pageLines = null;
	});