/* CSS */
$("body").append('<link rel="stylesheet" type="text/css" href="css/pageLocateToMap.css"/>');

/* VARIABLES */
var pageLocateToMap = {

    $page: null,

    init: function() {
        functionsGlobals.showLoading();
        pageLocateToMap.$page.find("#page_title").text(sessionStorage.getItem("stop_name"));

        if (!localStorage.getItem("array_paradas")) {
            sessionStorage.setItem("activeFunction", "pageLocateToMap.init()");
            CallServiceCAI(aConfig["gstr_webServiceURLCAI"], createSoapRequestgetStops(), "functionsGlobals.saveStops");
        } else pageLocateToMap.addContent();
    },

    addContent: function() {
        lat = sessionStorage.getItem("latitud");
        lng = sessionStorage.getItem("longitud");

        pageLocateToMap.createPoints(functionsGlobals.getURLParameter("filter"));
        pageLocateToMap.getStopCoords(functionsGlobals.getURLParameter("filter"));
    },

    getStopCoords: function(stop) {
        var lat1 = "";
        var lon1 = "";
        var aParadas = JSON.parse(localStorage.getItem("array_paradas")) || [];

        $.each(aParadas, function(i, item) {
            if (item.id_parada == stop) {
                lat1 = item.latitud;
                lon1 = item.longitud;
            }
        });

        if (sessionStorage.getItem("latitud") == null)
            pageLocateToMap.$page.find("#locate_stop").attr("href", "https://www.google.es/maps/dir/" + aConfig["default_lat"] + "," + aConfig["default_lng"] + "/" + lat1 + "," + lon1);
        else
            pageLocateToMap.$page.find("#locate_stop").attr("href", "https://www.google.es/maps/dir/" + sessionStorage.getItem("latitud") + "," + sessionStorage.getItem("longitud") + "/" + lat1 + "," + lon1);

    },

    createPoints: function(point) {
        var paradas = JSON.parse(localStorage.getItem("array_paradas"));

        $.each(paradas, function(i, item) {
            if (item.id_parada == point) {
                pageLocateToMap.setOpenLayersMarkers(item);
                return false;
            }
        });
    },

    setOpenLayersMarkers: function(point) {
        var distance = functionsGlobals.distanceBetweenPoint(sessionStorage.getItem('latitud'), sessionStorage.getItem('longitud'), point.latitud, point.longitud);
        var aParadas = JSON.parse(localStorage.getItem("array_paradas"));

        var sPoint = ol.proj.fromLonLat([eval(point.longitud), eval(point.latitud)]);
        var uPoint = ol.proj.fromLonLat([eval(lng), eval(lat)]);

        var stopsLayer = functionsGlobals.createOpenLayerPoint(sPoint, aConfig["gobl_icon_stop"], ".6", point);
        var userLayer = functionsGlobals.createOpenLayerPoint(uPoint, aConfig["gobl_icon_user"], ".6", null);

        pageLocateToMap.$page.find("#map-canvas-locate-to-map").empty();

        var view = new ol.View({
            center: sPoint,
            zoom: 16
        });

        var container = document.getElementById('popupOL');
        var content = document.getElementById('popupOL-content');
        var closer = document.getElementById('popupOL-closer');

        closer.onclick = function() {
            overlay.setPosition(undefined);
            closer.blur();
            return false;
        };

        var overlay = new ol.Overlay({
            element: container,
            autoPan: true,
            autoPanAnimation: {
                duration: 250
            }
        });

        fetch('https://www.geobilbao.eus/geobilbao/Main?gsservice=ls&gsrequest=wmts&idservice=WMTS_Geobilbao').then(function(response) {
            return response.text();
        }).then(function(text) {

            var parser = new ol.format.WMTSCapabilities();
            var result = parser.read(text);

            var options = ol.source.WMTS.optionsFromCapabilities(result, {
                layer: 'Urb_cartografia:Cartografia_10000_Web'
            });

            var source = new ol.source.WMTS( /** @type {!module:ol/source/WMTS~Options} */ (options));

            source.on('tileloaderror', function(event) {
                pageTravelMap.tileLoadingError()

            });

            pageLocateToMap.$map = new ol.Map({
                target: 'map-canvas-locate-to-map',
                layers: [
					new ol.layer.Tile({
								opacity: 1,
								minResolution: 0,
								maxResolution: 14,
								source: source
							}),
							
							new ol.layer.Tile({
								preload: Infinity,
								minResolution: 14,
								maxResolution: 1000,
								source: new ol.source.OSM({
									"url": "https://cartodb-basemaps-a.global.ssl.fastly.net/light_all/{z}/{x}/{y}.png",
								})
							}),
					],
                overlays: [overlay],
                loadTilesWhileAnimating: true,
                view: view
            });

			if (distance > 999) {
				distance = ((distance / 1000).toFixed(2)).replace(".", ",");;
				var distance_char = " km";
			} else var distance_char = " m";
	
			var lineas_IDA = [];
			var aux_aRoute = [];
			var lineas = [];
	
			setTimeout(function() {
				pageLocateToMap.$map.addLayer(stopsLayer);
				pageLocateToMap.$map.addLayer(userLayer);
				pageLocateToMap.$map.getView().setCenter(sPoint);
				pageLocateToMap.$map.updateSize();
	
				$.each(aParadas, function(i, item) {
					if (item.id_parada == point.id_parada) {
						functionsGlobals.getRutaOL(item.id_linea, "IDA", "pageLocateToMap.$map");
						functionsGlobals.getRutaOL(item.id_linea, "VLT", "pageLocateToMap.$map");
						functionsGlobals.getBusOL(item.id_linea, "IDA", "pageLocateToMap.$map");
						functionsGlobals.getBusOL(item.id_linea, "VLT", "pageLocateToMap.$map");
						lineas += item.id_linea + ", ";
					}
				});
			}, 2000);
	
			pageLocateToMap.$map.getViewport().addEventListener("click", function(e) {
				pageLocateToMap.$map.forEachFeatureAtPixel(pageLocateToMap.$map.getEventPixel(e), function(feature, layer) {
					if (layer.values_.element) {
						var coords = feature.getGeometry().getCoordinates();
	
						content.innerHTML = '<div class="marker-info-win">' +
							'<div class="marker-inner-win"><span class="marker-lines">' +
							'<h1 class="marker-heading">' + distance + distance_char + '</h1>' +
							'<h2 class="marker-heading">' + layer.values_.element.name_parada + '</h2><p class = "marker-lines">' +
							lineas + '</p></span></div></div>';
	
						overlay.setPosition(coords);
					}
				});
			});
			functionsGlobals.hideLoading();
        });
    },
};

/* EVENTS */

$(document).off(".locateToMap")

.on("pagecreate.locateToMap", "#page_locate_to_map", function() {
    pageLocateToMap.$page = $(this);
})

.on("pagebeforeshow.locateToMap", "#page_locate_to_map", function() {
    functionsGlobals.getLocation();
    projSourceCG = new Proj4js.Proj("EPSG:23030");
    projDestCG = new Proj4js.Proj("EPSG:4326");
    projDestGC = new Proj4js.Proj("EPSG:23030");
})

.on("pageshow.locateToMap", "#page_locate_to_map", function() {
    pageLocateToMap.init();
})

.on("pageremove.locateToMap", "#page_locate_to_map", function() {
    $(window).off(".locateToMap");
    $(document).off(".locateToMap");
    $('link[href="css/pageLocateToMap.css"]').remove();
    pageLocateToMap = null;
});