/* CSS */
$( "body" ).append('<link rel="stylesheet" type="text/css" href="css/pageNews.css"/>');

/* VARIABLES */
var pageNews = {
		
	$page : null,

	init: function() 
	{
		pageNews.addContent();
		pageNews.getData();

	},

	addContent : function() 
	{
		pageNews.$page.find("#page_title").text(gjson_lang['page_title_news']);
	},

	getData : function() 
	{

    	functionsGlobals.showLoading();

    	if ( !checkConnection() )
    	{
    		functionsGlobals.showMessage(gjson_lang['connectionError'], null);
    		return false;
    	}

		connection.getResponse(aConfig["URL_RSS_NEWS_"+language], "xml")
	    .done(function(data_response) {
	        pageNews.showData(data_response);
	    });

    		

           		


	},

	showData : function(data) 
	{

		pageNews.$page.find("#page-news-list").empty();
		
		if ($(data).find(' channel item ').length == 0)
			functionsGlobals.showMessage(gjson_lang['no_datos'], null);
		else
		{
			$(data).find(' channel item ').each(function(i)
			{

				html = '<a data-rel = "external" href = "'+$(this).find('link').text()+'">'+
							'<li data-icon="false">'+ 
							'<p class = "news_date">'+ functionsGlobals.getDateFormatted($(this).find('pubDate').text()) + '</p>'+
							'<h1>'+ $(this).find('title').text() + '</h1>'+
							'<p>'+ $(this).find('description').text()+ '</p>'+
							'</li></a>';


				pageNews.$page.find("#page-news-list").append(html);

			});

			pageNews.$page.find('#page-news-list').listview('refresh');
		}

		functionsGlobals.hideLoading();
	}


};

/* EVENTS */

$( document ).off(".news")

	.on("pagecreate.news", "#page_news", function()
	{
		pageNews.$page = $(this);
	})
	
	.on("pageshow.news", "#page_news", function()
	{
		pageNews.init();
	})

	.on("pageremove.news", "#page_news", function()
	{
		$( window ).off( ".news" );
		$( document ).off(".news");
		$( 'link[href="css/pageNews.css"]' ).remove();
		pageNews = null;
	});

