/* GOOGLE MAPS */	
/* CSS */
$( "body" ).append('<link rel="stylesheet" type="text/css" href="css/pageNextToMe.css"/>');
/* VARIABLES */
var pageNextToMe = {
		
	$page : null,

	init: function() 
	{		
		functionsGlobals.showLoading();
		pageNextToMe.$page.find("#page_title").text(gjson_lang['page_title_nextToMe']);

		if (!localStorage.getItem("array_paradas"))
			{
				sessionStorage.setItem("activeFunction", "pageNextToMe.init()");
		       	CallServiceCAI(aConfig["gstr_webServiceURLCAI"], createSoapRequestgetStops(), "functionsGlobals.saveStops");
			}
		else pageNextToMe.addContent();		
	},


	addContent : function() 
	{
		lat = sessionStorage.getItem("latitud");
		lng = sessionStorage.getItem("longitud");

		var lat1 = eval(lat) - eval(aConfig["distance_rate_lat"]);
		var lat2 = eval(lat) + eval(aConfig["distance_rate_lat"]);

		var lng1 = eval(lng) - eval(aConfig["distance_rate_lon"]);
		var lng2 = eval(lng) + eval(aConfig["distance_rate_lon"]);

		CallServiceCAI(aConfig["gstr_webServiceURLCAI"], createSoapRequestgetStopsNearMap(lng1,lat1,lng2,lat2), "pageNextToMe.createPoints");
	},

	createPoints : function(json) 
	{
	    pageNextToMe.resizeStopsList();	
		var aPoints = [];

		if (json.numberOfFeatures == undefined)
		{
			functionsGlobals.showMessage(gjson_lang['error_ajax']);
			$("#map-canvas-next-to-me").hide();
			return false;
		}		
		
		if (json.numberOfFeatures != "0")
		{
			if ( json.numberOfFeatures == 1)
			{
				var longiTextCoords = json.featureMembers.StopPoint.projection.PointGeometry.geometry.Point.pos.length;
				var posicionTextCoords = json.featureMembers.StopPoint.projection.PointGeometry.geometry.Point.pos.indexOf(" ");
				var latitud = json.featureMembers.StopPoint.projection.PointGeometry.geometry.Point.pos.substring(0, posicionTextCoords);
				var longitud = json.featureMembers.StopPoint.projection.PointGeometry.geometry.Point.pos.substring(posicionTextCoords+1, longiTextCoords);

				aPoints.push({
					nameParada: json.featureMembers.StopPoint.stopPointName.PT_FreeText.textGroup.LocalisedCharacterString,
					idParada: json.featureMembers.StopPoint.stopPointId.StopPointCode.identifier,
					latitud: latitud,
					longitud: longitud
				});	
			}
			else
			{
				$.each(json.featureMembers.StopPoint, function( i, item ) 
				{

					var longiTextCoords = item.projection.PointGeometry.geometry.Point.pos.length;
					var posicionTextCoords = item.projection.PointGeometry.geometry.Point.pos.indexOf(" ");
					var latitud = item.projection.PointGeometry.geometry.Point.pos.substring(0, posicionTextCoords);
					var longitud = item.projection.PointGeometry.geometry.Point.pos.substring(posicionTextCoords+1, longiTextCoords);

					aPoints.push({
						nameParada: item.stopPointName.PT_FreeText.textGroup.LocalisedCharacterString,
						idParada: item.stopPointId.StopPointCode.identifier,
						latitud: latitud,
						longitud: longitud
					});						
				});
			}
		}
		else
		{
			functionsGlobals.showMessage(gjson_lang['no_stops'], null);
			var windowHeight = $( window ).outerHeight();
			pageNextToMe.$page.find('#map-canvas-next-to-me').css("height", windowHeight*0.25);
		}
		
	    pageNextToMe.setOpenLayersMarkers(aPoints);	
	},

	setOpenLayersMarkers : function(points) 
	{
		var aParadas = JSON.parse(localStorage.getItem("array_paradas"));
		var aPointsOrder = [];
		pageNextToMe.$page.find("#map_stops_content").empty();

		var uPoint = ol.proj.fromLonLat([eval(lng), eval(lat)]);
		userLayer = functionsGlobals.createOpenLayerPoint(uPoint, aConfig["gobl_icon_user"], ".6", null);
		var stopsLayer = [];

		var view = new ol.View({
	      center: uPoint,
	      zoom: 15
	    });


		$("#map-canvas-next-to-me").empty();

		fetch('https://www.geobilbao.eus/geobilbao/Main?gsservice=ls&gsrequest=wmts&idservice=WMTS_Geobilbao').then(function(response) {
            return response.text();
        }).then(function(text) {

			var parser = new ol.format.WMTSCapabilities();
            var result = parser.read(text);

            var options = ol.source.WMTS.optionsFromCapabilities(result, {
                layer: 'Urb_cartografia:Cartografia_10000_Web'
            });


            var source = new ol.source.WMTS( /** @type {!module:ol/source/WMTS~Options} */ (options));

            source.on('tileloaderror', function(event) {
                pageTravelMap.tileLoadingError()

            });


			
			var map = new ol.Map({
				target: 'map-canvas-next-to-me',
				layers: [
					new ol.layer.Tile({
                        opacity: 1,
                        minResolution: 0,
                        maxResolution: 14,
                        source: source
					}),
					
					new ol.layer.Tile({
                        preload: Infinity,
                        minResolution: 14,
                        maxResolution: 1000,
                        source: new ol.source.OSM({
                            "url": "https://cartodb-basemaps-a.global.ssl.fastly.net/light_all/{z}/{x}/{y}.png",
                        })
                    }),
				],
				loadTilesWhileAnimating: true,
				view: view
			  });
	
			map.addLayer(userLayer);

// todo



$.each( points, function( i, item )  
		{	
			pos = i;
			var distance = functionsGlobals.distanceBetweenPoint(lat,lng, item.latitud,item.longitud);
			
			distance = Math.round(distance / 10) * 10;

			if (distance > 999)
			{
				distance = ((distance/1000).toFixed(2)).replace(".", ",");;
				var distance_char = " km";
			}	
			else var distance_char = " m";
				
			if (distance == 0)
				distance = 10;
			
				aPointsOrder.push({
					idParada: item.idParada,
					nameParada: item.nameParada,
					distance: distance,
					distance_char: distance_char,
					pos: pos
				});	

			var sPoint = ol.proj.fromLonLat([eval(item.longitud), eval(item.latitud)]);
      		stopsLayer[i] = functionsGlobals.createOpenLayerPoint(sPoint, aConfig["gobl_icon_stop"], ".6", item);
      		map.addLayer(stopsLayer[i]);  

	        var lineas = "";

	        $.each( aParadas, function( i, item2 )
	        {
	        	if (item.idParada == item2.id_parada)
					lineas += item2.id_linea + ", ";	
	        }); 
	        
	        lineas = lineas.substring(0, lineas.length-2);

			if (functionsGlobals.isFavorite(item.idParada))
				pageNextToMe.$page.find("#stop"+pos).append('<div class = "icon_favorite"><img src="img/stops/lista_favorito.png"></div>');
				
		});

		map.getViewport().addEventListener("click", function(e) 
		{
		    map.forEachFeatureAtPixel(map.getEventPixel(e), function (feature, layer) 
		    {
		    	if(layer.values_.element)
		    		$( "body" ).pagecontainer( "change", "StopTimes.html?stop="+layer.values_.element.idParada);
		    });
		});

		aPointsOrder.sort(functionsGlobals.SortByDistance);

		$.each( aPointsOrder, function( i, item )  
		{
			var html = '<li data-icon = "false"><a href = "StopTimes.html?stop='+item.idParada+'" data-stop="'+item.idParada+'"> ' + 
						'<div class="stop_list_v_line"></div>' +
						'<div class="stopCircle"></div>' +
						'<div class = "ui-grid-a">'+
						'<div class="stopName name_linea ui-block-a">'+ item.idParada +" - " +item.nameParada+ '</div>';

			if (functionsGlobals.geolocation_OK() == true)
				html += '<div class="ui-block-b stopDistance">'+item.distance+item.distance_char+'</div></div>';
			else
				html += '<div class="ui-block-b stopDistance"></div></div>';		

				html += '<div id="stopF'+i+'" class="div_favorite"></div>' +
						'<div class="stop_list_lines" id="stop'+item.pos+'">' + 
						'</div>' + 
						'</a></li>';
							
			pageNextToMe.$page.find("#map_stops_content").append(html);
			
			if (functionsGlobals.isFavorite(item.idParada))
				pageNextToMe.$page.find("#stopF"+i).html('<div class = "icon_favorite"><img src="img/stops/lista_favorito.png"></div>');

	        $.each( aParadas, function( j, item2 )
	        {
	        	if (item.idParada == item2.id_parada)
	        	{
	        		htmlLines = '<div class="line_list_id_list  line-color-div-'+item2.id_linea+'">'+item2.id_linea+'</div>';	
					pageNextToMe.$page.find("#stop"+item.pos).append(htmlLines);
	        	}	        		
	        }); 		
		});

		pageNextToMe.$page.find("#map_stops_content").listview( "refresh" );
		functionsGlobals.hideLoading();








		});



		
	},	

	resizeStopsList: function(json) 
	{
		var windowHeight = $( window ).outerHeight();
		pageNextToMe.$page.find('#map-canvas-next-to-me').css("height", windowHeight*0.4);
	},
};

/* EVENTS */


$( window ).off(".nextToMe")

	.on("resize.nextToMe", function()
	{
		pageNextToMe.resizeStopsList();
	});

$( document ).off(".nextToMe")

	.on("pagecreate.nextToMe", "#page_nextToMe", function()
	{
		pageNextToMe.$page = $(this);
		pageNextToMe.init();
	})

	.on("pagebeforeshow.nextToMe", "#page_nextToMe", function()
	{	
		functionsGlobals.getLocation();
	})

	.on("pageshow.nextToMe", "#page_nextToMe", function()
	{	
		pageNextToMe.$page.find('#btn_next_to_me').addClass("ui-btn-active");
	})

	.on("click.nextToMe", "#page_nextToMe .ui-footer .ui-block-b a", function(event)
	{
		functionsGlobals.showLoading();
	})

	.on("click.nextToMe", "#page_nextToMe #updateMap", function(event)
	{
		event.preventDefault();
		functionsGlobals.getLocation();
		pageNextToMe.init();
		return false;	
	})

	.on("click.nextToMe", "#page_nextToMe #showmap", function(event)
	{
		event.preventDefault();
		functionsGlobals.showLoading();
		$( "body" ).pagecontainer( "change", "NextToMeMap.html");
		return false;	
	})

	.on("pageremove.nextToMe", "#page_nextToMe", function()
	{
		$( window ).off( ".nextToMe" );
		$( document ).off(".nextToMe");
		$( 'link[href="css/pageNextToMe.css"]' ).remove();
		pageNextToMe = null;
	});

