/* CSS */
$( "body" ).append('<link rel="stylesheet" type="text/css" href="css/pageNextToMeMap.css"/>');

/* VARIABLES */
var pageNextToMeMap = {
		
	$page : null,

	init: function() 
	{
		functionsGlobals.showLoading();
		pageNextToMeMap.$page.find("#page_title").text(gjson_lang['page_title_nextToMeMap']);
		
		if (!localStorage.getItem("array_paradas"))
		{
			sessionStorage.setItem("activeFunction", "pageNextToMeMap.init()");
	       	CallServiceCAI(aConfig["gstr_webServiceURLCAI"], createSoapRequestgetStops(), "functionsGlobals.saveStops");
		}
		else pageNextToMeMap.addContent(); 	
	},

	addContent : function() 
	{		
		lat = sessionStorage.getItem("latitud");
		lng = sessionStorage.getItem("longitud");

		var lat1 = eval(lat) - eval(aConfig["distance_rate_lat"]);
		var lat2 = eval(lat) + eval(aConfig["distance_rate_lat"]);

		var lng1 = eval(lng) - eval(aConfig["distance_rate_lon"]);
		var lng2 = eval(lng) + eval(aConfig["distance_rate_lon"]);

		CallServiceCAI(aConfig["gstr_webServiceURLCAI"], createSoapRequestgetStopsNearMap(lng1,lat1,lng2,lat2), "pageNextToMeMap.createPoints");
	},

	createPoints : function(json) 
	{
		var aPoints = [];

		if (json.numberOfFeatures == undefined)
		{
			functionsGlobals.showMessage(gjson_lang['error_ajax']);
			$("#map-canvas-next-to-me-map").hide();
			return false;
		}		


		if (json.featureMembers != 0)
		{
			if ( json.numberOfFeatures == 1)
			{
				var longiTextCoords = json.featureMembers.StopPoint.projection.PointGeometry.geometry.Point.pos.length;
				var posicionTextCoords = json.featureMembers.StopPoint.projection.PointGeometry.geometry.Point.pos.indexOf(" ");
				var latitud = json.featureMembers.StopPoint.projection.PointGeometry.geometry.Point.pos.substring(0, posicionTextCoords);
				var longitud = json.featureMembers.StopPoint.projection.PointGeometry.geometry.Point.pos.substring(posicionTextCoords+1, longiTextCoords);

				aPoints.push({
					nameParada: json.featureMembers.StopPoint.stopPointName.PT_FreeText.textGroup.LocalisedCharacterString,
					idParada: json.featureMembers.StopPoint.stopPointId.StopPointCode.identifier,
					latitud: latitud,
					longitud: longitud
				});	
			}
			else
			{
				$.each(json.featureMembers.StopPoint, function( i, item ) 
				{
					var longiTextCoords = item.projection.PointGeometry.geometry.Point.pos.length;
					var posicionTextCoords = item.projection.PointGeometry.geometry.Point.pos.indexOf(" ");
					var latitud = item.projection.PointGeometry.geometry.Point.pos.substring(0, posicionTextCoords);
					var longitud = item.projection.PointGeometry.geometry.Point.pos.substring(posicionTextCoords+1, longiTextCoords);

					aPoints.push({
						nameParada: item.stopPointName.PT_FreeText.textGroup.LocalisedCharacterString,
						idParada: item.stopPointId.StopPointCode.identifier,
						latitud: latitud,
						longitud: longitud
					});				
				});
			}
		}
		else
		{
			functionsGlobals.showMessage(gjson_lang['no_stops'], null);
			$("#map-canvas-next-to-me-map").hide();
		}

	    pageNextToMeMap.setOpenLayersMarkers(aPoints);	
	},

	setOpenLayersMarkers : function(points) 
	{

		var aParadas = JSON.parse(localStorage.getItem("array_paradas"));
		var uPoint = ol.proj.fromLonLat([eval(lng), eval(lat)]);
		var userLayer = functionsGlobals.createOpenLayerPoint(uPoint, aConfig["gobl_icon_user"], ".6", null);
		var stopsLayer = [];

		var view = new ol.View({
			center: uPoint,
			zoom: 15
		});

		$("#map-canvas-next-to-me-map").empty();

		fetch('https://www.geobilbao.eus/geobilbao/Main?gsservice=ls&gsrequest=wmts&idservice=WMTS_Geobilbao').then(function(response) {
            return response.text();
        }).then(function(text) {

			var parser = new ol.format.WMTSCapabilities();
            var result = parser.read(text);

            var options = ol.source.WMTS.optionsFromCapabilities(result, {
                layer: 'Urb_cartografia:Cartografia_10000_Web'
            });

            var source = new ol.source.WMTS( /** @type {!module:ol/source/WMTS~Options} */ (options));

            source.on('tileloaderror', function(event) {
                pageTravelMap.tileLoadingError()

			});

			var map = new ol.Map({
				target: 'map-canvas-next-to-me-map',
				layers: [
				new ol.layer.Tile({
							opacity: 1,
							minResolution: 0,
							maxResolution: 14,
							source: source
						}),
						
						new ol.layer.Tile({
							preload: Infinity,
							minResolution: 14,
							maxResolution: 1000,
							source: new ol.source.OSM({
								"url": "https://cartodb-basemaps-a.global.ssl.fastly.net/light_all/{z}/{x}/{y}.png",
							})
						}),
				],
				loadTilesWhileAnimating: true,
				view: view
			});
			
			map.addLayer(userLayer);

			$.each( points, function( i, item )  
			{
				var sPoint = ol.proj.fromLonLat([eval(item.longitud), eval(item.latitud)]);
				  stopsLayer[i] = functionsGlobals.createOpenLayerPoint(sPoint, aConfig["gobl_icon_stop"], ".6", item);
				  map.addLayer(stopsLayer[i]);  
			});
		
			map.getViewport().addEventListener("click", function(e) 
			{
				map.forEachFeatureAtPixel(map.getEventPixel(e), function (feature, layer) 
				{
					if(layer.values_.element)
						$( "body" ).pagecontainer( "change", "StopTimes.html?stop="+layer.values_.element.idParada);
				});
			});
	
			functionsGlobals.hideLoading();

		});
	},	
};

/* EVENTS */

$( document ).off(".nextToMeMap")

	.on("pagecreate.nextToMeMap", "#page_nextToMe_map", function()
	{
		pageNextToMeMap.$page = $(this);
	})

	.on("pagebeforeshow.nextToMemap", "#page_nextToMe_map", function()
	{	
		functionsGlobals.getLocation();
	})

	.on("pageshow.nextToMemap", "#page_nextToMe_map", function()
	{
		pageNextToMeMap.init();
	})

	.on("pageremove.nextToMeMap", "#page_nextToMe_map", function()
	{
		$( window ).off( ".nextToMeMap" );
		$( document ).off(".nextToMeMap");
		$( 'link[href="css/pageNextToMeMap.css"]' ).remove();
		pageNextToMeMap = null;
	});
