/* CSS */
$( "body" ).append('<link rel="stylesheet" type="text/css" href="css/pageRates.css"/>');

/* VARIABLES */
var pageRates = {
		
	$page : null,

	init: function() 
	{
		pageRates.addContent();
		pageRates.getData();

	},

	addContent : function() 
	{
		pageRates.$page.find("#page_title").text(gjson_lang['page_title_rates']);
	},

	getData : function() 
	{

    	functionsGlobals.showLoading();
    	  	 
    	if ( !checkConnection() )
    	{
    		functionsGlobals.showMessage(gjson_lang['connectionError'], null);
    		return false;
    	}
    	
        	connection.getResponse(aConfig["URL_XML_TARIFAS_BILBOBUS"], "xml")
            .done(function(data_response) {
                      pageRates.showData(data_response);
            });

    		
	},

	showData : function(data) 
	{
		var RatesImages=[];

		RatesImages[0] = '<img src="img/rates/tarifas_ocasional.png" />';
		RatesImages[1] = '<img src="img/rates/tarifas_creditrans.png" />';
		RatesImages[2] = '<img src="img/rates/tarifas_barik.png" />';
		RatesImages[3] = '<img src="img/rates/tarifas_gizatrans.png" />';
		RatesImages[4] = '<img src="img/rates/tarifas_hirukotrans.png" />';
		RatesImages[5] = '<img src="img/rates/tarifas_hirukotrans.png" />';
		RatesImages[6] = '';

		pageRates.$page.find("#page-rates-content").empty();

		var cabecera = '<div class ="ui-block-a cabecera"><p>'+gjson_lang['ticket_multi']+'</p></div>'+
					   '<div class ="ui-block-b cabecera"><p>'+gjson_lang['price_multi']+'</p></div>';

		pageRates.$page.find("#page-rates-content").append(cabecera);
		


		$(data).find(' listaTitulos titulo ').each(function(i)
		{
			
			 if ( $(this).find('obs_'+language).text().indexOf('€') != -1)
			 	var subclase = 'rates-opt-observations';
			 else
			 	var subclase = 'rates-opt-observations2';

			if ($(this).find('imagen_'+language).text() != "")
			{
				
				html = '<div class = "ui-block-a">'+
					   '<p class="rates-types"><img src="'+ $(this).find('imagen_'+language).text() + '"/></p>' + 
					   '<p class="rates-opt-title">' + $(this).find('nombre_'+language).text() + '</p>' + 
					   '<p class="'+subclase+'">' + $(this).find('obs_'+language).text() + '</p></div>'+
					   '<div class = "ui-block-b">'+
					   '<h1 class="rates-opt-price">'+ $(this).find('precio_viaje').text() + '</h1></div>'+
					   '<div class="separator_lines"></div>';				
			}
			else
			{
				html = '<div class = "ui-block-a">'+
					   '<p class="rates-opt-title">' + $(this).find('nombre_'+language).text() + '</p>' + 
					   '<p class="'+subclase+'">' + $(this).find('obs_'+language).text() + '</p></div>'+
					   '<div class = "ui-block-b">'+
					   '<h1 class="rates-opt-price">'+ $(this).find('precio_viaje').text() + '</h1></div>'+
					   '<div class="separator_lines"></div>';	
			}


			pageRates.$page.find("#page-rates-content").append(html);

		});

		$(data).find(' listaObservaciones observacion ').each(function(i)
		{
			pageRates.$page.find('#page-rates-content').append('</div><div class="rates-info">' + $(this).find(language).text() + '</div>');
		});

		//pageRates.$page.find('#page-rates-content').listview('refresh');
		pageRates.$page.find('#page-rates-content').trigger( "updatelayout" );
		functionsGlobals.hideLoading();
	}
};

/* EVENTS */

$( document ).off(".rates")

	.on("pagecreate.rates", "#page_rates", function()
	{
		pageRates.$page = $(this);
	})

	.on("pageshow.rates", "#page_rates", function()
	{
		pageRates.init();

	})

	.on("pageremove.rates", "#page_rates", function()
	{
		$( window ).off( ".rates" );
		$( document ).off(".rates");
		$( 'link[href="css/pageRates.css"]' ).remove();
		pageRates = null;
	});

