/* CSS */
$( "body" ).append('<link rel="stylesheet" type="text/css" href="css/pageSchedule.css"/>');

/* VARIABLES */
var pageSchedule = {
		
	$page : null,
	aLineInfo : [],
	active_tab : 1,
	sentido: null,
	stop_sel: 0,


	init: function() 
	{
		functionsGlobals.showLoading();
		pageSchedule.sentido = sessionStorage.getItem("sentido") || "1";			
		pageSchedule.getData(sessionStorage.getItem("direction"), null, 0);
		pageSchedule.$page.find("#schedule_content_1").addClass("ui-btn-active");
		
    	var active_linea = sessionStorage.getItem("codigoLineaActiva");
    	
    	if( active_linea.indexOf("G") != -1)
    		pageSchedule.$page.find("#tab_variable").text(gjson_lang.page_schedule_tab1_G);


	},

	getData : function(direction, stop_id, stop_pos) 
	{
    	
    	functionsGlobals.showLoading();
    	pageSchedule.$page.find(".info_error").hide();
    	sessionStorage.setItem("direction", direction);
    	pageSchedule.$page.find("#page_title").text(sessionStorage.getItem("codigoLineaActiva")+" - "+sessionStorage.getItem("name_linea"+direction));


    	pageSchedule.showScheduleStop(stop_id, stop_pos);	


	    //CallService(aConfig["gstr_webServiceURL"], createSoapRequestGetLineInfo(sessionStorage.getItem("codigoLineaActiva")), "pageSchedule.saveLineInfo");	

	},


	showPatternOrden: function(data)
	{
		var aParadasOrden = [];



		if (data.featureMembers.ServicePattern.serviceLinkSequence != "")
		{
			
			$.each( data.featureMembers.ServicePattern.serviceLinkSequence.LinkSequenceAsPoints.points, function( i, item ) 
			{
			
			if('StopPoint' in item.StopPointInServicePattern.point && item.StopPointInServicePattern.point.StopPoint.stopPointId != undefined)
			{
				aParadasOrden.push({
					orden: parseInt(item.StopPointInServicePattern.order),
					identifier: item.StopPointInServicePattern.point.StopPoint.stopPointId.StopPointCode.identifier
				});		
			}
			else
			{
				
				

				var aPoint = data.featureMembers.ServicePattern.serviceLinkSequence.LinkSequenceAsPoints.points;

				if('StopPoint' in item.StopPointInServicePattern.point)
					var xlink_point =  item.StopPointInServicePattern.point.StopPoint;
				else
					var xlink_point =  item.StopPointInServicePattern.point;
				
				$.each(xlink_point, function(key, value) {
					var xlink_code = value.replace("#StopPoint:", "");

					if('StopPoint' in item.StopPointInServicePattern.point)
						var xlinkPoint = functionsGlobals.getXlinkStop2(aPoint, xlink_code);
					else
						var xlinkPoint = functionsGlobals.getXlinkStop(aPoint, xlink_code);

					aParadasOrden.push({
						orden: parseInt(item.StopPointInServicePattern.order),
						identifier: xlinkPoint
					});
				});



			}



			});


			aParadasOrden.sort(functionsGlobals.SortByOrden);	
			pageSchedule.showPattern(aParadasOrden);
		}else
		{
			functionsGlobals.showMessage(gjson_lang['no_stops2'], null);
		}
		
		functionsGlobals.hideLoading();

	},


	showPattern : function(data) 
	{
		
		var aParadas = JSON.parse(localStorage.getItem("array_paradas"));
		var schedule_stops = [];
		var pos;


		if (data != "")
		{
			$.each( data, function( i, item ) 
			{
				
				pos = i;

				$.each( aParadas, function( i, item2 ) 
				{
					
					if (item.identifier == item2.id_parada)
					{					
						if (item2.name_parada == undefined)
							var nameParada = "No registrada";
						else 
							var nameParada = item2.name_parada;


						

						schedule_stops.push({
									idParada: item.identifier,
									nameParada: nameParada,
									linea: item2.id_linea,
									idLineaSentido: sessionStorage.getItem("sentido"),
									orden: item.orden
								});	

						sessionStorage.setItem("schedule_stops_"+pageSchedule.sentido, JSON.stringify(schedule_stops));


						codigoLinea = item2.id_linea;
						return false;
										}
				});
			});

  		}



    	pageSchedule.showScheduleStop(null, 0);	

	},



	showScheduleStop : function(stop_id, stop_pos) 
	{
    	functionsGlobals.showLoading();


    	var aListParadas = JSON.parse(sessionStorage.getItem("schedule_stops_"+pageSchedule.sentido));

    	if(aListParadas == null)
    	{
			CallServiceCAI(aConfig["gstr_webServiceURLCAI"], createSoapRequestGetPattern(sessionStorage.getItem('direction')), 'pageSchedule.showPatternOrden');
    		return false;
    	}
    		

    	var html_menu_options = "";

    	for (var i=0, len=aListParadas.length; i < aListParadas.length; i++)
		{
			if (aListParadas[i].idParada == stop_id)
				html_menu_options += "<h1 class = 'sel_parada' data-idParada = "+aListParadas[i].idParada+" data-posParada = "+i+">"+aListParadas[i].idParada+" - "+aListParadas[i].nameParada+"</h1>";
			else
				html_menu_options += "<h1 data-idParada = "+aListParadas[i].idParada+" data-posParada = "+i+">"+aListParadas[i].idParada+" - "+aListParadas[i].nameParada+"</h1>";
		}

    	$(".menu_popup_options").empty().append(html_menu_options); 	

    	if(stop_pos == 0)
    		pageSchedule.$page.find('.menu_popup_options h1[data-posparada="0"]').addClass('sel_parada');

		pageSchedule.$page.find("#scheduleSel_stop span").text(aListParadas[stop_pos].idParada+" - "+aListParadas[stop_pos].nameParada);
		pageSchedule.$page.find("#scheduleSel_stop").attr("data-stop-sel",aListParadas[stop_pos].idParada);
		var stop = aListParadas[stop_pos].idParada;
		var linea = sessionStorage.getItem("codigoLineaActiva");


    		$.ajax({
				url: aConfig["URL_BBLISTHORP"]+"&p0="+linea+"&p1="+stop+"&p2="+pageSchedule.sentido,
				dataType: "json",
				cache: false,
				async: false
				}).done(function(json) {
					pageSchedule.saveLineInfo(json.RESPUESTA);
				})
				.error(function(xhRequest, textStatus, errorThrown) {
					pageSchedule.$page.find("#schedule_content_1").empty();
			    	pageSchedule.$page.find("#schedule_content_2").empty();
			    	pageSchedule.$page.find("#schedule_content_3").empty();
					functionsGlobals.showMessage(gjson_lang['no_stops2'], null);
					functionsGlobals.hideLoading();
				});
	  
	},


	saveLineInfo : function(data)
	{
		pageSchedule.aLineInfo.length = 0;

		if(data.LISTA.DETALLE != "" && data.LISTA.DETALLE != undefined)
		{
		$.each( data.LISTA.DETALLE, function( i, item ) 
		//$.each( data.LISTA.DETALLE, function( i, item ) 
		{
				pageSchedule.aLineInfo.push({
					cod_sentido: item.COD_SENTIDO,
					tipo_dia: item.TIPO_DIA,
					horas_salida: item.HORAS_SALIDA,
					nombre_sentido: item.NOMBRE_SENTIDO,
					cod_servicio: item.COD_SERVICIO
				});
			});	
			pageSchedule.showLineInfo();
		}else
		{
	    	pageSchedule.$page.find("#schedule_content_1").empty();
    		pageSchedule.$page.find("#schedule_content_2").empty();
    		pageSchedule.$page.find("#schedule_content_3").empty();
	    	functionsGlobals.showMessage(gjson_lang['no_stops2'], null);
	    	functionsGlobals.hideLoading();
		}
	},

	showLineInfo : function() 
	{
    	pageSchedule.$page.find("#schedule_content_1").empty();
    	pageSchedule.$page.find("#schedule_content_2").empty();
    	pageSchedule.$page.find("#schedule_content_3").empty();

    	var aServicios = [];
    	var aOrder = [];
    	var aOrder2 = [];


		$.each( pageSchedule.aLineInfo, function( i, item ) 
		{	
			if(aServicios.indexOf(item.cod_servicio) == -1)     
							aServicios.push(item.cod_servicio);
		});		

		$.each( pageSchedule.aLineInfo, function( i, item ) 
		{
			for (var j=0, len=aServicios.length; j < len; j++)
			{
				if ( item.cod_sentido == pageSchedule.sentido && item.cod_servicio == aServicios[j])
				{
					for (var i=0, len=item.horas_salida.length; i < len; i=i+5)
					{
						time = item.horas_salida.substring(i, i+5);

						aOrder.push({
							tipo_dia: item.tipo_dia,
							horas_salida: time
						});

						
					}
				}
			}

		});	

		
		if (sessionStorage.getItem("codigoLineaActiva").indexOf("G") != -1)
		{
			for (var x=0, len=aOrder.length; x < len; x++) 
			{
				var hours = aOrder[x].horas_salida.substring(0, 2);
				var minutes = aOrder[x].horas_salida.substring(3, 5);

		
				orden = hours+'-'+minutes;

				if (hours == "00")
					orden = '99'+'-'+minutes;

				if(hours >= 24)
				{
					hours = hours - 24;
					if (hours < 10)
						var horas_salida = "0"+hours+":"+minutes;
					else
						var horas_salida = hours+":"+minutes;
				}
				else
					var horas_salida = aOrder[x].horas_salida;

				


				aOrder2.push({
					tipo_dia: aOrder[x].tipo_dia,
					horas_salida: horas_salida,
					orden: orden
				});
		
			}

			aOrder2.sort(functionsGlobals.SortByOrden);			
		}
		else
		{
			for (var x=0, len=aOrder.length; x < len; x++) 
			{
				var hours = aOrder[x].horas_salida.substring(0, 2);
				var minutes = aOrder[x].horas_salida.substring(3, 5);
				orden = hours+'-'+minutes;

				if (hours == "00")
					orden = '99'+'-'+minutes;

				aOrder2.push({
					tipo_dia: aOrder[x].tipo_dia,
					horas_salida: aOrder[x].horas_salida,
					orden: orden
				});
			}

			aOrder2.sort(functionsGlobals.SortByOrden);			
		}

		

			for (var x=0, len=aOrder2.length; x < len; x++) 
			{
				pageSchedule.$page.find("#schedule_content_"+aOrder2[x].tipo_dia).append("<div class = 'separador_horas'>"+aOrder2[x].horas_salida+"</div>");
			}

			
			functionsGlobals.hideLoading();


	},

	changeDirection : function() 
	{

		if(sessionStorage.getItem("direction") == sessionStorage.getItem("filter1"))
		{
			pageSchedule.sentido = 2;		
			pageSchedule.getData(sessionStorage.getItem("filter2"), pageSchedule.stop_sel, 0);	
			
		}
		else
		{
			pageSchedule.sentido = 1;	
			pageSchedule.getData(sessionStorage.getItem("filter1"), pageSchedule.stop_sel, 0);
				
		}			

	},

};

/* EVENTS */

$( document ).off(".schedule")

	.on("pagecreate.schedule", "#page_schedule", function()
	{
		pageSchedule.$page = $(this);
	})

	.on("pageshow.schedule", "#page_schedule", function()
	{
		pageSchedule.init();
	})
	.on("click.schedule", "#page_schedule .footer_links", function(event)
	{
		event.preventDefault();
		if ($(this).attr("id") == 'footer_stops' ) $( "body" ).pagecontainer( "change", "stops.html?filter=" + sessionStorage.getItem("filter1")+"&filter2="+sessionStorage.getItem("filter2") );
		if ($(this).attr("id") == 'footer_route' ) $( "body" ).pagecontainer( "change", "travelMap.html?id=" + sessionStorage.getItem("direction")+"&name="+sessionStorage.getItem("name_linea"+sessionStorage.getItem("direction")));
		if ($(this).attr("id") == 'footer_schedule' ) $( "body" ).pagecontainer( "change", "schedule.html?filter=" + sessionStorage.getItem("filter1")+"&filter2="+sessionStorage.getItem("filter2") );	
		if ($(this).attr("id") == 'footer_lineNews' ) $( "body" ).pagecontainer( "change", "lineNews.html");
		return false;	
	})

	.on("click.schedule", "#page_schedule #back_btn_schedule", function(event)
	{
		event.preventDefault();

      	if (sessionStorage.getItem("actual_StopTimes") && sessionStorage.getItem("back_complete"))
      		window.history.back();
     	else
        	$( "body" ).pagecontainer( "change", "lines.html");

		return false;
	})
	
	.on("click.schedule", "#page_schedule #changeDirection", function(event)
	{
		event.preventDefault();
		pageSchedule.changeDirection();
		return false;	
	})


	.on("click.schedule", "#scheduleSel_stop", function(event)
	{ 
	  event.preventDefault(); 
	  $(window).resize();

	  $( "#menu_popup" ).popup('open',{
	    transition: "flip"
	  });

	  return false;   
	})

	.on("click.schedule", ".menu_popup_options h1", function(event)
	{ 
	  event.preventDefault(); 
	  $(".info_error").css("display", "none");
	  pageSchedule.$page.find("#scheduleSel_stop span").text($(this).text());
	  pageSchedule.$page.find("#scheduleSel_stop").attr("data-stop-sel", $(this).attr("data-idParada"));
	  pageSchedule.$page.find("#scheduleSel_stop").attr("data-stop-pos", $(this).attr("data-posParada"));
	  pageSchedule.stop_sel = $(this).attr("data-idParada");
	  pageSchedule.showScheduleStop($(this).attr("data-idParada"), $(this).attr("data-posParada"));
	  $(".ui-popup").popup("close");
	  return false;   
	})



	.on("pageremove.schedule", "#page_schedule", function()
	{
		$( window ).off( ".schedule" );
		$( document ).off(".schedule");
		$( 'link[href="css/pageSchedule.css"]' ).remove();
		pageSchedule = null;
	});
