/* CSS */
$( "body" ).append('<link rel="stylesheet" type="text/css" href="css/pageSelectStop.css"/>');

/* VARIABLES */
var pageSelectStop = {
		
	$page : null,
	carga_stops: false,
	subjectSelected:"",
	lineSelected:"",
	stopSelected:"",

	init: function() 
	{
		pageSelectStop.addContent();
		pageSelectStop.subjectSelected = functionsGlobals.getURLParameter("subject") || "";
		pageSelectStop.lineSelected = functionsGlobals.getURLParameter("line") || "";
		pageSelectStop.stopSelected = functionsGlobals.getURLParameter("stop") || "";
		pageSelectStop.getData();
	},

	addContent : function() 
	{
		pageSelectStop.$page.find("#page_title").text(gjson_lang['page_title_allStops']);
		pageSelectStop.$page.find("#myFilter").attr("placeholder",gjson_lang['search_stop']);
	},

	getData : function() 
	{
		functionsGlobals.showLoading();

		if (!localStorage.getItem("array_paradas"))
			{
				sessionStorage.setItem("activeFunction", "pageSelectStop.getData()");

		       	CallServiceCAI(aConfig["gstr_webServiceURLCAI"], createSoapRequestgetStops(), "functionsGlobals.saveStops");
		       	
			}
		else
		{
			functionsGlobals.carga_paradas = true;
	    	pageSelectStop.quitarLoading();
	    	pageSelectStop.showStops();
		}

		
	},


	showStops : function() 
	{

    	var aParadas = JSON.parse(localStorage.getItem("array_paradas"));
    	var aParadasAux = [];
    	var aStops = [];

		pageSelectStop.$page.find("#all_stops_content").empty();

 	    $.each(aParadas, function(i, item) 
	    {
			if(aParadasAux.indexOf(item.name_parada) == -1)     
				aParadasAux.push(item.name_parada);
	    });   	

 	    aParadasAux.sort();

	    $.each(aParadasAux, function(i, item) 
	    {
		    $.each(aParadas, function(i, item2) 
		    {
				if(item == item2.name_parada)
				{
					aStops.push({
						idParada: item2.id_parada,
						nameParada: item,
						codigoLinea: item2.id_linea,
						latitud: item2.latitud,
						longitud: item2.longitud
					});	
					return false;				
				}
		
		    });
	    });

	    var lineSelected = pageSelectStop.lineSelected;

	    for (var i=0, len=aStops.length; i < aStops.length; i++)
	    {
			if( lineSelected === "" || ( lineSelected !== "" && lineSelected == aStops[i].codigoLinea ) )
			{
				var distance = functionsGlobals.distanceBetweenPoint(sessionStorage.getItem('latitud'),sessionStorage.getItem('longitud'), aStops[i].latitud,aStops[i].longitud);

				if (distance > 999)
				{
					distance = ((distance/1000).toFixed(2)).replace(".", ",");
					var distance_char = " km";
				}	
				else
					var distance_char = " m";
				

				var pos = i;
				var html = '<li  data-icon = "false" ><a href = "#" data-stop="'+aStops[i].idParada+'"> ' + 
							'<div class = "ui-grid-a">'+
							'<div class="StopName ui-block-a">'+ aStops[i].idParada +" - " +aStops[i].nameParada+ '</div>';
				if (functionsGlobals.geolocation_OK() == true)
					html += '<div class="stopDistance ui-block-b">'+distance+distance_char+'</div>';		
	
					html += '</div></div>'+
							'<div class="stop_list_lines" id="stop'+pos+'">' + 
							'</div>' + 
							'<div class = "div_favorite" id ="favorite'+pos+'"></div>'+
							'<div class="listview_border"></div>'+
							'</li></a>';

				pageSelectStop.$page.find("#all_stops_content").append(html);

				$.each( aParadas, function( j, item2 ) 
				{
					if (aStops[i].nameParada == item2.name_parada)
					{
						
						htmlLines = '<div class="line_list_id_list" style="color:'+functionsGlobals.getColorLine(item2.id_linea)+'">'+item2.id_linea+'</div>';	
						pageSelectStop.$page.find("#stop"+pos).append(htmlLines);
					}

				});

				if (functionsGlobals.isFavorite(aStops[i].idParada))
				{
					pageSelectStop.$page.find("#favorite"+pos).append('<div class = "icon_favorite"><img src="img/stops/lista_favorito.png"></div>');
				}
			}
	    }  
		
		pageSelectStop.$page.find("#all_stops_content").listview( "refresh" );
		pageSelectStop.carga_stops = true;
		pageSelectStop.quitarLoading();
	},
	quitarLoading : function(data) 
	{		
		if(functionsGlobals.carga_paradas && pageSelectStop.carga_stops)
			functionsGlobals.hideLoading();
	},
	createURL: function()
	{
		var amb1 = "&";
		var amb2 = "&";

		var line = (pageSelectStop.lineSelected === "") ? "" : "line="+pageSelectStop.lineSelected;
		var subject = (pageSelectStop.subjectSelected === "") ? "" : "subject="+pageSelectStop.subjectSelected;
		var stop = (pageSelectStop.stopSelected === "") ? "" : "stop="+pageSelectStop.stopSelected;

		if(line === "")
			amb1 = "";

		if(subject === "")
			amb2 = "";

		return "suggestions.html?"+line+amb1+stop+amb2+subject;
	}

};

/* EVENTS */

$( document ).off(".selectStop")

	.on("pagecreate.selectStop", "#page_select_stop", function()
	{
		pageSelectStop.$page = $(this);
		functionsGlobals.getLocation();
	})

	.on("pageshow.selectStop", "#page_select_stop", function()
	{
		pageSelectStop.init();
	})

	.on("click.selectStop", "#page_select_stop #back_btn_select_stop", function(event)
	{
		event.preventDefault();
		$( "body" ).pagecontainer( "change", pageSelectStop.createURL() );
		return false;
	})

	.on("click.selectStop", "#page_select_stop #all_stops_content a", function(event)
	{
		event.preventDefault();
		var stopNameComplete = $(".StopName", this).text();
		pageSelectStop.stopSelected = stopNameComplete;
		
		$( "body" ).pagecontainer( "change", pageSelectStop.createURL() );
		return false;
	})

	.on("click.selectStop", "#page_select_stop #btn_filtro", function(event)
  	{
	   	event.preventDefault(); 
	    if(pageSelectStop.$page.find(".div_search").is(":visible"))
	    {
			pageSelectStop.$page.find(".div_search").hide();
			pageSelectStop.$page.find(".ui-footer").show();
			$("#all_stops_content").css("padding-top", "0");

			if(device_platform == "IOS")
	    	{
		        $("#app_header").css("position", "fixed");
		        $(".div_search").css("position", "fixed");
	    	}

	      	$('#myFilter').blur();
	    }
	    else
	    {
	    	// BUGFIX HEADER & KEYBOARD SHOWED
	    	if(device_platform == "IOS")
	        {
	            $("#app_header").css("position", "absolute");
	            $(".div_search").css("position", "absolute");
	        }


	      $(".ui-footer").hide();
	      pageSelectStop.$page.find(".div_search").show();
	      $("#all_stops_content").css("padding-top", "4em");
	      $('#myFilter').focus();

	      setTimeout(function(){
	        $(".ui-footer").show();
	      }, 1000);

	    }
	    return false;
  	})	

	.on("pageremove.selectStop", "#page_select_stop", function()
	{
		$( window ).off( ".selectStop" );
		$( document ).off(".selectStop");
		$( 'link[href="css/pageSelectStop.css"]' ).remove();
		pageSelectStop = null;
	});