/* CSS */
$("body").append('<link rel="stylesheet" type="text/css" href="css/pageStopTimes.css"/>');
var actual_parada_lineas = [];
var actual_parada_lineas2 = [];
var timeoutReloadTimes = null;
/* VARIABLES */
var pageStopTimes = {

    $page: null,
    aLineInfo: [],
    active_tab: 1,
    name_stop: "",
    carga_stops_list: false,
    carga_lineas: false,
    internalStopID: null,


    init: function() {
        pageStopTimes.getLocalData();
        if (localStorage.getItem("array_favorites"))
            pageStopTimes.checkFavorites();

        //Bucle de update times
        timeoutReloadTimes = setTimeout(function() {
            $("#updateTime").click();
        }, 30000);
    },

    addContent: function() {

        if (functionsGlobals.carga_paradas && pageStopTimes.carga_lineas) {
            var aParadas = JSON.parse(localStorage.getItem("array_paradas"));
            var stopAvailable = false;
            pageStopTimes.$page.find("#page_title").text(gjson_lang['page_title_stop_times']);

            $.each(aParadas, function(i, item) {
                if (item.id_parada == functionsGlobals.getURLParameter("stop")) {
                    pageStopTimes.$page.find("#stop_title h1").text(item.name_parada);
                    sessionStorage.setItem("stop_name", item.name_parada);
                    var distance = functionsGlobals.distanceStops(functionsGlobals.getURLParameter("stop"), sessionStorage.getItem("latitud"), sessionStorage.getItem("longitud"));

                    if (distance > 999) {
                        distance = ((distance / 1000).toFixed(2)).replace(".", ",");;
                        var distance_char = " km";
                    } else
                        var distance_char = " m";


                    if (functionsGlobals.geolocation_OK() == true)
                        pageStopTimes.$page.find("#stop_title p").html("Parada " + item.id_parada + "<p class = 'distance'>" + distance + distance_char + "</p>");
                    else
                        pageStopTimes.$page.find("#stop_title p").html(gjson_lang["suggestions_send_stop"] + " " + item.id_parada);

                    pageStopTimes.internalStopID = item.id_parada_interno;
                    pageStopTimes.name_stop = item.name_parada;

                    stopAvailable = true;
                    $(".info_error").hide();
                    return false;
                }
            });

            if (!stopAvailable) {
                pageStopTimes.$page.find(".info_error h1").text(gjson_lang["info_error"]);
                pageStopTimes.$page.find(".ui-navbar").hide();
                pageStopTimes.$page.find(".info_error").show();
            }


            pageStopTimes.getData();
            pageStopTimes.getStopCoords(functionsGlobals.getURLParameter("stop"));
        }
    },

    getStopCoords: function(stop) {
        var lat1 = "";
        var lon1 = "";
        var aParadas = JSON.parse(localStorage.getItem("array_paradas"));
        actual_parada_lineas = [];

        $.each(aParadas, function(i, item) {
            if (item.id_parada == stop) {
                lat1 = item.latitud;
                lon1 = item.longitud;
                actual_parada_lineas.push(item.id_linea);

            }

        });

        if (!lat1 && !lon1)
            pageStopTimes.$page.find("#locate_stop").addClass("disabled");
        else if (sessionStorage.getItem("latitud") == null)
            pageStopTimes.$page.find("#locate_stop").attr("href", "https://www.google.es/maps/dir/" + aConfig["default_lat"] + "," + aConfig["default_lng"] + "/" + lat1 + "," + lon1);
        else
            pageStopTimes.$page.find("#locate_stop").attr("href", "https://www.google.es/maps/dir/" + sessionStorage.getItem("latitud") + "," + sessionStorage.getItem("longitud") + "/" + lat1 + "," + lon1);


    },


    getLocalData: function() {

        functionsGlobals.showLoading();

        if (!localStorage.getItem("array_lineas") || !localStorage.getItem("array_paradas")) {

            sessionStorage.setItem("activeFunction", "pageStopTimes.init()");

            CallServiceCAI(aConfig["gstr_webServiceURLCAI"], createSoapRequestgetStops(), "functionsGlobals.saveStops");
            CallServiceCAI(aConfig["gstr_webServiceURLCAI"], SoapgetLines(), "pageStopTimes.LoadLines");

        } else {

            pageStopTimes.carga_lineas = true;
            functionsGlobals.carga_paradas = true;
            pageStopTimes.quitarLoading();
            pageStopTimes.addContent();

        }

    },



    getData: function() {

        functionsGlobals.showLoading();

        if (!checkConnection()) {
            functionsGlobals.showMessage(gjson_lang['connectionError'], null);
            return false;
        }

        CallServiceCAI(aConfig["gstr_webServiceURLCAI"], createSoapRequesgetEstimatedCall(functionsGlobals.getURLParameter("stop")), 'pageStopTimes.showStops');

    },

    LoadLines: function(data) {

        var aLineas = [];

        $.each(data.featureMembers.Line, function(i, item) {
            if (item.routesForLine != undefined) {
                if (item.routesForLine[0].Route.direction.Direction.identity.DirectionCode.identifier == "IDA")
                    aLineas.push({
                        id_linea: item.identity.LineCode.identifier,
                        name_linea: item.lineName,
                        id_Route0: item.routesForLine[0].Route.identity.RouteCode.identifier,
                        id_Route1: item.routesForLine[1].Route.identity.RouteCode.identifier
                    });
                else
                    aLineas.push({
                        id_linea: item.identity.LineCode.identifier,
                        name_linea: item.lineName,
                        id_Route0: item.routesForLine[1].Route.identity.RouteCode.identifier,
                        id_Route1: item.routesForLine[0].Route.identity.RouteCode.identifier
                    });
            }
        });


        localStorage.setItem("array_lineas", JSON.stringify(aLineas));
        pageStopTimes.carga_lineas = true;
        pageStopTimes.quitarLoading();
        pageStopTimes.addContent();

    },


    showStops: function(data) {
        var aLineas = JSON.parse(localStorage.getItem("array_lineas"));
        var aParadas = JSON.parse(localStorage.getItem("array_paradas"));
        var id_linea;
        var time;
        var arrival_time;
        var destino;
        var html;
        var aPointsOrder = [];



        pageStopTimes.$page.find("#stopTimes_content").empty();


        if (data.numberOfFeatures != "0") {

            if (data.numberOfFeatures == 1) {
                $.each(aLineas, function(i, item2) {
                    if (data.featureMembers.EstimatedCall.isPartOf.EstimatedVehicleJourney.hasJourneyPatternInfo.JourneyPatternInfo.externalLineRef.LineCode.identifier == item2.id_linea) {

                        id_linea = data.featureMembers.EstimatedCall.isPartOf.EstimatedVehicleJourney.hasJourneyPatternInfo.JourneyPatternInfo.externalLineRef.LineCode.identifier;
                        destino = data.featureMembers.EstimatedCall.isPartOf.EstimatedVehicleJourney.hasJourneyPatternInfo.JourneyPatternInfo.directionName.PT_FreeText.textGroup.LocalisedCharacterString;
                        time = data.featureMembers.EstimatedCall.hasAimedArrivalTimes.AimedArrivalTimes.aimedArrivalTime;
                        arrival_time = pageStopTimes.calculateTime(time, new Date());
                        id_Route0: item2.id_Route0;
                        id_Route1: item2.id_Route1;

                        //busDelayTime : margen de tiempo para que el bus llegue a la parada 
                        if (arrival_time > busDelayTime && arrival_time <= 99) {

                            if (arrival_time < 0) {
                                arrival_time = 0;
                            }

                            aPointsOrder.push({
                                id_linea: id_linea,
                                name_linea: item2.name_linea,
                                arrival_time: arrival_time,
                                destino: destino
                            });
                        }
                    }
                });
            } else {
                $.each(data.featureMembers.EstimatedCall, function(i, item) {

                    //$features = $('gml\\:featureMember, featureMember', $xmlData),

                    $.each(aLineas, function(i, item2) {


                        if (item.isPartOf.EstimatedVehicleJourney.hasJourneyPatternInfo.JourneyPatternInfo.externalLineRef.LineCode.identifier == item2.id_linea) {
                            id_linea = item.isPartOf.EstimatedVehicleJourney.hasJourneyPatternInfo.JourneyPatternInfo.externalLineRef.LineCode.identifier;
                            time = item.hasAimedArrivalTimes.AimedArrivalTimes.aimedArrivalTime;
                            arrival_time = pageStopTimes.calculateTime(time, new Date());
                            destino = item.isPartOf.EstimatedVehicleJourney.hasJourneyPatternInfo.JourneyPatternInfo.directionName.PT_FreeText.textGroup.LocalisedCharacterString;

                            //busDelayTime : margen de tiempo para que el bus llegue a la parada 
                            console.warn(arrival_time);
                            if (arrival_time > busDelayTime && arrival_time <= 99) {

                                if (arrival_time < 0) {
                                    arrival_time = 0;
                                }

                                aPointsOrder.push({
                                    id_linea: id_linea,
                                    name_linea: item2.name_linea,
                                    arrival_time: arrival_time,
                                    id_Route0: item2.id_Route0,
                                    id_Route1: item2.id_Route1,
                                    destino: destino
                                });
                            }
                        }
                    });
                });
            }
        } else {
            //functionsGlobals.showMessage(gjson_lang['no_datos'], null);
            //$("#btn_location").hide();
            //$("#btn_favorite").hide();
        }

        aPointsOrder.sort(functionsGlobals.SortByArrivalTime);

        /*if(aPointsOrder.length == 0) 
        {
        	functionsGlobals.showMessage(gjson_lang['no_datos'], null);
        	$("#btn_location").hide();
        	$("#btn_favorite").hide();
        }
        */

        $.each(aPointsOrder, function(i, item) {

            if (sessionStorage.getItem("codigoLineaActiva") == item.id_linea)
                var class_from_linea = "class_from_linea";
            else
                var class_from_linea = "";

            html = '<div class="ui-grid-b ' + class_from_linea + '">' +
                '<div class="ui-block-a"> <div class="line_list_id" style="color:' + functionsGlobals.getColorLine(item.id_linea) + '">' + item.id_linea + '</div></div>' +
                '<div class="ui-block-b name_linea"><a href = "#" data-name = "' + item.name_linea + '" data-line= "' + item.id_linea + '" data-Route0="' + item.id_Route0 + '" data-Route1="' + item.id_Route1 + '">' + item.destino + '</a></div>' +
                '<div class="ui-block-c"> <div class="time_circle">' + item.arrival_time + '' + "'" + '</div></div>' +
                '</div>';

            pageStopTimes.$page.find("#stopTimes_content").append(html).show();
        });


        actual_parada_lineas2 = [];

        $.each(aPointsOrder, function(i, item) {
            actual_parada_lineas2.push(item.id_linea);
        });

        pageStopTimes.$page.find("#stopTimes_content_no_time").empty();

        $.each(actual_parada_lineas, function(i, item) {

            if ($.inArray(item, actual_parada_lineas2) == -1) {

                var alin = JSON.parse(localStorage.getItem("array_lineas")) || [];


                $.each(alin, function(i, item2) {
                    if (item2.id_linea == item) {

                        if (sessionStorage.getItem("codigoLineaActiva") == item)
                            var class_from_linea = "class_from_linea";
                        else
                            var class_from_linea = "";



                        var html = '<div class="ui-grid-b ' + class_from_linea + '">' +
                            '<div class="ui-block-a"> <div class="line_list_id" style="color:' + functionsGlobals.getColorLine(item) + '">' + item + '</div></div>' +
                            '<div class="ui-block-b name_linea"><a href = "#" data-name = "' + item2.name_linea + '" data-line= "' + item + '" data-Route0="' + item2.id_Route0 + '" data-Route1="' + item2.id_Route1 + '">' + item2.name_linea + '</a></div>' +
                            '<div class="ui-block-c"> <div class="time_circle"> - </div></div>' +
                            '</div>';

                        pageStopTimes.$page.find("#stopTimes_content_no_time").append(html);

                    }

                });

            }

        });


        /*if ($.inArray('example', myArray) != -1)
        {
          // found it
        }
        */

        pageStopTimes.$page.find("#stopTimes_content").listview("refresh");

        pageStopTimes.carga_stops_list = true;
        pageStopTimes.quitarLoading();

    },

    addFavorite: function(stop) {
        var aParadas = JSON.parse(localStorage.getItem("array_paradas"));

        pageStopTimes.$page.find("#title_favorite").text(gjson_lang['favorites_popup_title_add']);

        if (language == "eu")
            pageStopTimes.$page.find("#content_popup_favorite").html('<b>' + pageStopTimes.name_stop + " </b>" + gjson_lang['favorites_popup_content_add_1']);
        else
            pageStopTimes.$page.find("#content_popup_favorite").html(gjson_lang['favorites_popup_content_add_1'] + pageStopTimes.name_stop + gjson_lang['favorites_popup_content_add_2']);

        pageStopTimes.$page.find('#popup_favorite').popup('open');

        if (!localStorage.getItem("array_favorites"))
            var aFavorites = [];
        else
            var aFavorites = JSON.parse(localStorage.getItem("array_favorites"));

        $.each(aParadas, function(i, item) {
            if (item.id_parada == stop) {
                aFavorites.push({
                    id_parada: item.id_parada,
                    name_parada: item.name_parada,
                    id_linea: item.id_linea,
                    latitud: item.latitud,
                    longitud: item.longitud
                });
            }
        });


        localStorage.setItem("array_favorites", JSON.stringify(aFavorites));
        pageStopTimes.$page.find("#btn_favorite").attr("data-active", "true");
        pageStopTimes.checkFavorites();
    },

    deleteFavorite: function(stop) {
        var aParadas = JSON.parse(localStorage.getItem("array_paradas"));
        var aFavorites = JSON.parse(localStorage.getItem("array_favorites"));
        var aFavoritesAUX = []

        pageStopTimes.$page.find("#title_favorite").text(gjson_lang['favorites_popup_title_del']);

        if (language == "eu")
            pageStopTimes.$page.find("#content_popup_favorite").html('<b>' + pageStopTimes.name_stop + " </b>" + gjson_lang['favorites_popup_content_del_1']);
        else
            pageStopTimes.$page.find("#content_popup_favorite").html(gjson_lang['favorites_popup_content_del_1'] + pageStopTimes.name_stop + gjson_lang['favorites_popup_content_del_2']);

        pageStopTimes.$page.find('#popup_favorite').popup('open');

        $.each(aFavorites, function(i, item) {
            if (item.id_parada != stop) {
                aFavoritesAUX.push({
                    id_parada: item.id_parada,
                    name_parada: item.name_parada,
                    id_linea: item.id_linea
                });
            }
        });

        localStorage.setItem("array_favorites", JSON.stringify(aFavoritesAUX));
        pageStopTimes.$page.find("#btn_favorite").attr("data-active", "false");
        pageStopTimes.checkFavorites();
    },
    checkFavorites: function() {

        if (localStorage.getItem("array_favorites") != "") {
            var aFavorites = JSON.parse(localStorage.getItem("array_favorites"));

            if (aFavorites.length != 0)
                $.each(aFavorites, function(i, item) {

                    if (item.id_parada == functionsGlobals.getURLParameter("stop")) {
                        pageStopTimes.$page.find("#btn_favorite").addClass("navbar_selected");
                        pageStopTimes.$page.find("#btn_favorite").attr("data-active", "true");
                        pageStopTimes.$page.find("#btn_favorite").find("img").attr("src", "img/stops/btn_favorite_on.png");
                        return false;
                    } else {
                        pageStopTimes.$page.find("#btn_favorite").removeClass("navbar_selected");
                        pageStopTimes.$page.find("#btn_favorite").attr("data-active", "false");
                        pageStopTimes.$page.find("#btn_favorite").find("img").attr("src", "img/stops/btn_favorite_off.png");
                    }
                });
            else {
                pageStopTimes.$page.find("#btn_favorite").removeClass("navbar_selected");
                pageStopTimes.$page.find("#btn_favorite").find("img").attr("src", "img/stops/btn_favorite_off.png");
            }
        }
    },

    calculateTime: function(startDate, endDate) {
        var startTime = new Date(startDate);
        var endTime = new Date(endDate);

        var diff = startTime.getTime() - endTime.getTime();
        minutes = Math.floor((diff / 1000) / 60);
        return (minutes);
    },


    quitarLoading: function(data) {
        if (pageStopTimes.carga_stops_list && pageStopTimes.carga_lineas && functionsGlobals.carga_paradas)
            functionsGlobals.hideLoading();
    }

};

/* EVENTS */

$(document).off(".stopTimes")

.on("pagecreate.stopTimes", "#page_stopTimes", function() {
    pageStopTimes.$page = $(this);

    if (functionsGlobals.getURLParameter("origen") == "QR") {
        var browserLang = window.navigator.language;
        if (browserLang != undefined) {
            var userLang = window.navigator.language.substring(0, 2);
            if (userLang !== localStorage.getItem("language")) {
                localStorage.setItem("language", userLang);
                location.reload();
            }
        }

        $("#back_btn_StopTimes").hide();
        CallService(aConfig["gstr_webServiceURL"], createSoapRequestGetLineColors(), "functionsGlobals.saveLineColors");
    } else
        $("#menu_stopTimes").hide();

})

.on("pageshow.stopTimes", "#page_stopTimes", function() {
    functionsGlobals.getLocation();
    sessionStorage.removeItem("back_complete");
    if (functionsGlobals.getURLParameter("origen") != "QR") {
        sessionStorage.setItem("actual_StopTimes", $.mobile.navigate.history.stack[$.mobile.navigate.history.stack.length - 1].url);

        if (!sessionStorage.getItem("back_StopTimes"))
            sessionStorage.setItem("back_StopTimes", $.mobile.navigate.history.stack[$.mobile.navigate.history.stack.length - 2].url);
    }

    pageStopTimes.init();

})

.on("pagechange.stopTimes", "#page_stopTimes", function() {

})

.on("click.stopTimes", "#page_stopTimes #btn_favorite", function(event) {
    event.preventDefault();
    if (pageStopTimes.$page.find("#btn_favorite").attr("data-active") == "true")
        pageStopTimes.deleteFavorite(functionsGlobals.getURLParameter("stop"));
    else
        pageStopTimes.addFavorite(functionsGlobals.getURLParameter("stop"));
    return false;
})

.on("click.stopTimes", "#page_stopTimes .name_linea a", function(event) {
    event.preventDefault();
    sessionStorage.setItem("codigoLineaActiva", $(this).attr('data-line'));

    //var names = $(this).find(".name_linea a").text().split('-');
    var names = $(this).attr('data-name').split('-');

    sessionStorage.setItem("name_linea", $.trim(names[0]) + " - " + $.trim(names[1]));
    sessionStorage.setItem("name_linea" + $(this).attr("data-Route0"), $.trim(names[0]) + " - " + $.trim(names[1]));
    sessionStorage.setItem("name_linea" + $(this).attr("data-Route1"), $.trim(names[1]) + " - " + $.trim(names[0]));
    sessionStorage.setItem("direction", $(this).attr("data-Route0"));
    sessionStorage.setItem("back_complete", "no");
    $("body").pagecontainer("change", "stops.html?filter=" + $(this).attr("data-Route0") + '&filter2=' + $(this).attr("data-Route1"));
    return false;
})



.on("click.stopTimes", "#page_stopTimes #updateTime", function(event) {
    event.preventDefault();
    pageStopTimes.getData();

    //Bucle de update times
    timeoutReloadTimes = setTimeout(function() {
        $("#updateTime").click();
    }, 30000);

    return false;
})


.on("click.stopTimes", "#page_stopTimes #btn_location", function(event) {
    event.preventDefault();
    $("body").pagecontainer("change", "locateToMap.html?filter=" + functionsGlobals.getURLParameter("stop"));
    return false;
})

.on("click.stopTimes", "#page_stopTimes #back_btn_StopTimes", function(event) {
    event.preventDefault();
    if (!sessionStorage.getItem("back_StopTimes") || sessionStorage.getItem("back_StopTimes") == 'undefined')
        $("body").pagecontainer("change", "lines.html");
    else
        $("body").pagecontainer("change", sessionStorage.getItem("back_StopTimes"));

    sessionStorage.removeItem("back_StopTimes");
    return false
})


.on("pageremove.stopTimes", "#page_stopTimes", function() {
    $(window).off(".stopTimes");
    $(document).off(".stopTimes");
    $('link[href="css/pageStopTimes.css"]').remove();
    pageStopTimes = null;
    clearTimeout(timeoutReloadTimes);

});