/* CSS */
$( "body" ).append('<link rel="stylesheet" type="text/css" href="css/pageStops.css"/>');

/* VARIABLES */
var pageStops = {
		
	$page : null,
	carga_lineasParadas0 : false,
	carga_lineasParadas1 : false,

	init: function() 
	{
		sessionStorage.setItem("filter1", functionsGlobals.getURLParameter("filter"));	
		sessionStorage.setItem("filter2", functionsGlobals.getURLParameter("filter2"));	

		if (localStorage.getItem("array_favorites_lineas"))
			pageStops.checkFavorites(sessionStorage.getItem("codigoLineaActiva"));

		if(!sessionStorage.getItem("sentido"))
			sessionStorage.setItem("sentido", "1");	


		if( !localStorage.getItem("array_lineas") || !localStorage.getItem("array_paradas"))
		{
	        if(sessionStorage.getItem("direction"))
	        	sessionStorage.setItem("activeFunction", "pageStops.getData("+sessionStorage.getItem("direction")+")");
			else
				sessionStorage.setItem("activeFunction", "pageStops.getData("+functionsGlobals.getURLParameter("filter")+")");
		
	        sessionStorage.setItem("activeFunction", "pageStops.getData()");

			CallServiceCAI(aConfig["gstr_webServiceURLCAI"], createSoapRequestgetStops(), "functionsGlobals.saveStops");
	        CallServiceCAI(aConfig["gstr_webServiceURLCAI"], SoapgetLines(), "pageStops.LoadLines");	        		
		}
		else
		{
			if(sessionStorage.getItem("direction"))
				pageStops.getData(sessionStorage.getItem("direction"));
			else
				pageStops.getData(functionsGlobals.getURLParameter("filter"));
		}
	},

	LoadLines : function(data) 
	{

		var aLineas = [];

		$.each( data.featureMembers.Line, function( i, item ) 
		{
			if (item.routesForLine != undefined)
			{
				if(item.routesForLine[0].Route.direction.Direction.identity.DirectionCode.identifier == "IDA")
					aLineas.push({
						id_linea: item.identity.LineCode.identifier,
						name_linea: item.lineName,
						id_Route0: item.routesForLine[0].Route.identity.RouteCode.identifier,
						id_Route1: item.routesForLine[1].Route.identity.RouteCode.identifier
					});		
				else
					aLineas.push({
						id_linea: item.identity.LineCode.identifier,
						name_linea: item.lineName,
						id_Route0: item.routesForLine[1].Route.identity.RouteCode.identifier,
						id_Route1: item.routesForLine[0].Route.identity.RouteCode.identifier
					});					
			}		
		});

		
		localStorage.setItem("array_lineas", JSON.stringify(aLineas));

	},
	getData : function(direction) 
	{
    	functionsGlobals.showLoading();
 		sessionStorage.setItem("direction", direction);	


 		pageStops.$page.find("#page_title").text(sessionStorage.getItem("codigoLineaActiva")+" - "+sessionStorage.getItem("name_linea"+direction));
       
	    if ( !checkConnection() )
		{
		    functionsGlobals.showMessage(gjson_lang['connectionError'], null);
		    return false;
		}


	    if ( !localStorage.getItem("array_lineasParadas"+direction))
	    {
		    CallServiceCAI(aConfig["gstr_webServiceURLCAI"], createSoapRequestGetPattern(sessionStorage.getItem('direction')), 'pageStops.showPatternOrden');		
		}else
		{
		   	pageStops.localData(direction);
		}
		
	},


	showIndividualLine : function(data) 
	{
		pageStops.$page.find('#title_line').text(data.featureMembers.Line.lineName);
	},


	showPatternOrden: function(data)
	{
		
		var aParadasOrden = [];


		if (data.featureMembers.ServicePattern.serviceLinkSequence != "")
		{
			
			$.each( data.featureMembers.ServicePattern.serviceLinkSequence.LinkSequenceAsPoints.points, function( i, item ) 
			{
			
			if('StopPoint' in item.StopPointInServicePattern.point && item.StopPointInServicePattern.point.StopPoint.stopPointId != undefined)
			{
				aParadasOrden.push({
					orden: parseInt(item.StopPointInServicePattern.order),
					identifier: item.StopPointInServicePattern.point.StopPoint.stopPointId.StopPointCode.identifier
				});		
			}
			else
			{
				
				var aPoint = data.featureMembers.ServicePattern.serviceLinkSequence.LinkSequenceAsPoints.points;

				if('StopPoint' in item.StopPointInServicePattern.point)
					var xlink_point =  item.StopPointInServicePattern.point.StopPoint;
				else
					var xlink_point =  item.StopPointInServicePattern.point;
				
				$.each(xlink_point, function(key, value) {
					var xlink_code = value.replace("#StopPoint:", "");

					if('StopPoint' in item.StopPointInServicePattern.point)
						var xlinkPoint = functionsGlobals.getXlinkStop2(aPoint, xlink_code);
					else
						var xlinkPoint = functionsGlobals.getXlinkStop(aPoint, xlink_code);

					aParadasOrden.push({
						orden: parseInt(item.StopPointInServicePattern.order),
						identifier: xlinkPoint
					});
				});


			}



			});

			aParadasOrden.sort(functionsGlobals.SortByOrden);	
			pageStops.showPattern(aParadasOrden);
		}else
		{
			functionsGlobals.showMessage(gjson_lang['no_stops2'], null);
			//pageStops.$page.find("#stops_content").append("<p>"+gjson_lang['no_stops2']+"</p>")
		}
		
		functionsGlobals.hideLoading();

	},

	showPattern : function(data) 
	{
		var aParadas = JSON.parse(localStorage.getItem("array_paradas"));
		var aRoute = [];
		var schedule_stops = [];
		var nameParada;
		var id_linea;
		var id_linea_sentido = functionsGlobals.getURLParameter("filter");
		var pos;
		var direction = sessionStorage.getItem("direction");	

		var distance = [];
		var distance_char = [];
		

		pageStops.$page.find("#stops_content").empty();

		if (data != "")
		//if (data.featureMembers!="" && data.featureMembers!=undefined)
		{
			$.each( data, function( i, item ) 
			{
				
				pos = i;

				$.each( aParadas, function( i, item2 ) 
				{
					distance[pos] = functionsGlobals.distanceBetweenPoint(sessionStorage.getItem('latitud'),sessionStorage.getItem('longitud'), item2.latitud,item2.longitud);

					if (distance[pos] > 999)
					{
						distance[pos]  = ((distance[pos]/1000).toFixed(2)).replace(".", ",");
						distance_char[pos] = " km";
					}
						
					else
						distance_char[pos] = " m";
					
					if (item.identifier == item2.id_parada)
					{					
						if (item2.name_parada == undefined)
							nameParada = "No registrada";
						else 
							 nameParada = item2.name_parada;


						schedule_stops.push({
									idParada: item.identifier,
									nameParada: nameParada,
									linea: item2.id_linea,
									idLineaSentido: sessionStorage.getItem("sentido"),
									orden: item.orden
								});	

						sessionStorage.setItem("schedule_stops_"+sessionStorage.getItem("sentido"), JSON.stringify(schedule_stops));


						codigoLinea = item2.id_linea;
						return false;
					


					}
				});

				var html = '<li data-icon = "false"><a href = "#" data-stop="'+item.identifier+'">' + 
							'<div class="stop_list_v_line"></div>' +
							'<div class="stopCircle"></div>' +
							'<div class="ui-grid-a">' +
							'<div class="StopName name_linea ui-block-a"> '+ item.identifier +" - " +nameParada+ '</div>';

				if (functionsGlobals.geolocation_OK() == true)
					html +=	'<div class="stopDistance ui-block-b">'+distance[pos]+distance_char[pos]+'</div>';

					html +=	'</div><div class="stop_list_lines" id="stop'+pos+'">' + 
							'</div>' + 
							'<div id="stopF'+pos+'" class="div_favorite"></div>' +
							'<div class="listview_border"></div>'+
							'</a></li>';

				pageStops.$page.find("#stops_content").append(html);

				if (functionsGlobals.isFavorite(item.identifier))
				{
					pageStops.$page.find("#stopF"+pos).append('<div class = "icon_favorite"><img src="img/stops/lista_favorito.png"></div>');
				}
				
				$.each( aParadas, function( i, item2 ) 
				{
					if (item.identifier == item2.id_parada)
					{					
						var html="";
						$.each( aParadas, function( i, item3 ) 
						{		
							if(item2.id_parada == item3.id_parada)
							{
								html += '<div class="line_list_id_list" style="color:'+functionsGlobals.getColorLine(item3.id_linea)+'">'+item3.id_linea+'</div>';	
								id_linea = item3.id_linea;

								aRoute.push({
									orden: item.orden,
									idLineaSentido: id_linea_sentido,
									idParada: item.identifier,
									nameParada: nameParada,
									idLinea: item3.id_linea,
									latitud:item2.latitud,
									longitud:item2.longitud,
								});		

							}	
											
						});

						pageStops.$page.find("#stop"+pos).append(html);
						return false;
					}


				});

		});

		pageStops.$page.find("#stops_content").listview( "refresh" );	
		//BORRADO localStorage.setItem("array_lineasParadas"+direction, JSON.stringify(aRoute));
		pageStops.carga_lineasParadas0 = true;
		}else
		{
			functionsGlobals.showMessage(gjson_lang['no_stops2'], null);
			//pageStops.$page.find("#stops_content").append("<p>"+gjson_lang['no_stops2']+"</p>")
		}
		

		functionsGlobals.hideLoading();

	},



	localData : function(direction) 
	{

		var html="";
		var pos;
		var aDirectionAUX = [];
		var aStops = [];
		var aDirection = JSON.parse(localStorage.getItem("array_lineasParadas"+direction));

	    $.each(aDirection, function(i, item) 
	    {
			if(aDirectionAUX.indexOf(item.idParada) == -1)     
				aDirectionAUX.push(item.idParada);
	    });

	    $.each(aDirectionAUX, function(i, item) 
	    {
		    $.each(aDirection, function(i, item2) 
		    {
				if(item == item2.idParada)
				{
					aStops.push({
						idParada: item,
						nameParada: item2.nameParada,
						codigoLinea: item2.idLinea,
						latitud: item2.latitud,
						longitud: item2.longitud
					});	
					return false;				
				}
		
		    });
	    });

		pageStops.$page.find("#stops_content").empty();

		$.each( aStops, function( i, item ) 
		{
			pos = i;

			var distance = functionsGlobals.distanceBetweenPoint(sessionStorage.getItem('latitud'),sessionStorage.getItem('longitud'), item.latitud,item.longitud);

				if (distance > 999)
				{
					distance = ((distance/1000).toFixed(2)).replace(".", ",");
					var distance_char = " km";
				}	
				else
					var distance_char = " m";
			
				var html = '<li data-icon = "false"><a href = "#" data-stop="'+item.idParada+'">' + 
							'<div class="stop_list_v_line"></div>' +
							'<div class="stopCircle"></div>' +
							'<div class="ui-grid-a">' +
							'<div class="StopName name_linea ui-block-a"> '+ item.idParada +" - " +item.nameParada+ '</div>';

				if (functionsGlobals.geolocation_OK() == true)
					html += '<div class="stopDistance ui-block-b">'+distance+distance_char+'</div>';

					html += '</div><div class="stop_list_lines" id="stop'+pos+'">' + 
							'</div>' + 
							'<div id="stopF'+pos+'" class="div_favorite"></div>' +
							'<div class="listview_border"></div>'+
							'</a></li>';
							

				pageStops.$page.find("#stops_content").append(html);

			$.each( aDirection, function( i, item2 ) 
			{
				if (item.idParada == item2.idParada)
				{
					
					htmlLines = '<div class="line_list_id_list" style="color:'+functionsGlobals.getColorLine(item2.idLinea)+'">'+item2.idLinea+'</div>';	
					pageStops.$page.find("#stop"+pos).append(htmlLines);
				}

			});

			
			if (functionsGlobals.isFavorite(item.idParada))
			{
				pageStops.$page.find("#stopF"+pos).append('<div class = "icon_favorite"><img src="img/stops/lista_favorito.png"></div>');
			}

		});
		pageStops.$page.find("#stops_content").listview( "refresh" );
		functionsGlobals.hideLoading();
	},

	changeDirection : function() 
	{

		if(sessionStorage.getItem("direction") == functionsGlobals.getURLParameter("filter"))
		{
			pageStops.getData(functionsGlobals.getURLParameter("filter2"));
			sessionStorage.setItem("sentido", "2");				
		}
		else
		{
			pageStops.getData(functionsGlobals.getURLParameter("filter"));
			sessionStorage.setItem("sentido", "1");	
		}

	},

	validateJson: function(item)
	{
		if (item.hasOwnProperty('journeyPatternLinkSequence'))
			if (item.journeyPatternLinkSequence.hasOwnProperty('LinkSequenceAsPoints'))
				if (item.journeyPatternLinkSequence.LinkSequenceAsPoints.hasOwnProperty('points'))
					if (item.journeyPatternLinkSequence.LinkSequenceAsPoints.points.hasOwnProperty('PointInJourneyPattern'))
						if (item.journeyPatternLinkSequence.LinkSequenceAsPoints.points.PointInJourneyPattern.hasOwnProperty('point'))
							if (item.journeyPatternLinkSequence.LinkSequenceAsPoints.points.PointInJourneyPattern.point.hasOwnProperty('StopPoint'))
								if (item.journeyPatternLinkSequence.LinkSequenceAsPoints.points.PointInJourneyPattern.point.StopPoint.hasOwnProperty('stopPointId'))
									if (item.journeyPatternLinkSequence.LinkSequenceAsPoints.points.PointInJourneyPattern.point.StopPoint.stopPointId.hasOwnProperty('StopPointCode'))
										return true;
	},

	addFavorite: function(line) 
	{
		var aLineas = JSON.parse(localStorage.getItem("array_lineas"));
		pageStops.$page.find("#title_favorite").text(gjson_lang['favorites_popup_title_add']);
		
		if (language == "eu")
			pageStops.$page.find("#content_popup_favorite").html('<b>'+sessionStorage.getItem("name_linea")+" </b>"+gjson_lang['favorites_popup_content_add_line_1']);
		else
			pageStops.$page.find("#content_popup_favorite").html(gjson_lang['favorites_popup_content_add_line_1']+sessionStorage.getItem("name_linea")+gjson_lang['favorites_popup_content_add_line_2']);

		pageStops.$page.find('#popup_favorite').popup('open');


		if (!localStorage.getItem("array_favorites_lineas"))
			var aFavorites = [];
		else
			var aFavorites = JSON.parse(localStorage.getItem("array_favorites_lineas"));

			
		$.each( aLineas, function( i, item ) 
		{
			if (item.id_linea == line)
			{
				aFavorites.push({
					id_linea: item.id_linea,
					name_linea: item.name_linea,
					id_Route0: item.id_Route0,
					id_Route1: item.id_Route1
				});					
			}
		});

		localStorage.setItem("array_favorites_lineas", JSON.stringify(aFavorites));
		pageStops.$page.find("#btn_favorite_line").attr("data-active", "true");
		pageStops.checkFavorites(line);
	},

	deleteFavorite: function(linea) 
	{
		var aLineas = JSON.parse(localStorage.getItem("array_lineas"));
		var aFavorites = JSON.parse(localStorage.getItem("array_favorites_lineas"));
		var aFavoritesAUX = []

		pageStops.$page.find("#title_favorite").text(gjson_lang['favorites_popup_title_del']);


		if (language == "eu")
			pageStops.$page.find("#content_popup_favorite").html('<b>'+sessionStorage.getItem("name_linea")+" </b>"+gjson_lang['favorites_popup_content_del_1']);
		else
			pageStops.$page.find("#content_popup_favorite").html(gjson_lang['favorites_popup_content_del_1']+sessionStorage.getItem("name_linea")+gjson_lang['favorites_popup_content_del_2']);

		pageStops.$page.find('#popup_favorite').popup('open');

		$.each( aFavorites, function( i, item ) 
		{
			if (item.id_linea != linea)
			{
				aFavoritesAUX.push({
					id_linea: item.id_linea,
					name_linea: item.name_linea,
					id_Route0: item.id_Route0,
					id_Route1: item.id_Route1
				});					
			}
		});

		localStorage.setItem("array_favorites_lineas", JSON.stringify(aFavoritesAUX));
		pageStops.$page.find("#btn_favorite_line").attr("data-active", "false");
		pageStops.checkFavorites(linea);
	},

	checkFavorites : function(line)
	{

		if (localStorage.getItem("array_favorites_lineas") != "")
		{
			var aFavorites = JSON.parse(localStorage.getItem("array_favorites_lineas"));

			if (aFavorites.length != 0)
				$.each( aFavorites, function( i, item ) 
				{

					if (item.id_linea == line)
					{
						pageStops.$page.find("#btn_favorite_line").addClass("navbar_selected");
						pageStops.$page.find("#btn_favorite_line").attr("data-active", "true");
						pageStops.$page.find("#btn_favorite_line").find("img").attr("src", "img/stops/btn_favorite_on.png");	
						return false;		
					}else
					{
						pageStops.$page.find("#btn_favorite_line").removeClass("navbar_selected");
						pageStops.$page.find("#btn_favorite_line").attr("data-active", "false");
						pageStops.$page.find("#btn_favorite_line").find("img").attr("src", "img/stops/btn_favorite_off.png");				
					}
				});	
			else
			{
				pageStops.$page.find("#btn_favorite_line").removeClass("navbar_selected");
				pageStops.$page.find("#btn_favorite_line").find("img").attr("src", "img/stops/btn_favorite_off.png");				
			}
		} 
	},
	quitarLoading : function(data) 
	{		
		//if(pageStops.carga_lineasParadas0 && pageStops.carga_lineasParadas1)
			functionsGlobals.hideLoading();
	}

};

/* EVENTS */

$( document ).off(".stops")

	.on("pagecreate.stops", "#page_stops", function()
	{
		pageStops.$page = $(this);
	})

	.on("pageshow.stops", "#page_stops", function()
	{
		functionsGlobals.getLocation();
		if ( sessionStorage.getItem("codigoLineaActiva") == "null" || !sessionStorage.getItem("codigoLineaActiva"))
       		$( "body" ).pagecontainer( "change", "lines.html");
       else
			pageStops.init();
	})

	.on("click.stops", "#page_stops .footer_links", function(event)
	{
		event.preventDefault();
		if ($(this).attr("id") == 'footer_stops' ) $( "body" ).pagecontainer( "change", "stops.html?filter=" + sessionStorage.getItem("filter1")+"&filter2="+sessionStorage.getItem("filter2") );
		if ($(this).attr("id") == 'footer_route' ) $( "body" ).pagecontainer( "change", "travelMap.html?id=" + sessionStorage.getItem("direction")+"&name="+sessionStorage.getItem("name_linea"+sessionStorage.getItem("direction")));
		if ($(this).attr("id") == 'footer_schedule' ) $( "body" ).pagecontainer( "change", "schedule.html?filter=" + sessionStorage.getItem("filter1")+"&filter2="+sessionStorage.getItem("filter2") );
		if ($(this).attr("id") == 'footer_lineNews' ) $( "body" ).pagecontainer( "change", "lineNews.html");	
		return false;	
	})

	.on("click.stops", "#page_stops #stops_content a", function(event)
	{
		event.preventDefault();
		var sentido = sessionStorage.getItem("sentido") -1;	
		$( "body" ).pagecontainer( "change", "StopTimes.html?stop=" + $(this).attr("data-stop")+"&sentido_linea="+sentido );
		return false
	})

	.on("click.stops", "#page_stops #btn_changeDirection", function(event)
	{
		event.preventDefault();
		pageStops.changeDirection();
		//pageStops.getData(sessionStorage.getItem("direction"));
		return false;	
	})

	.on("click.stops", "#page_stops #back_btn_stops", function(event)
	{
		event.preventDefault();

      	if (sessionStorage.getItem("actual_StopTimes") && sessionStorage.getItem("back_complete"))
      		window.history.back();      		
      	else if (sessionStorage.getItem("back_favorite"))
			$( "body" ).pagecontainer( "change", "favorites_lineas.html");    		
     	else
     		$( "body" ).pagecontainer( "change", "lines.html");      	

		return false;
	})

	.on("click.stops", "#page_stops #btn_favorite_line", function(event)
	{
		event.preventDefault();
		if (pageStops.$page.find("#btn_favorite_line").attr("data-active") == "true")
			pageStops.deleteFavorite(sessionStorage.getItem("codigoLineaActiva"));
		else
			pageStops.addFavorite(sessionStorage.getItem("codigoLineaActiva"));
		return false;	
	})

	.on("pageremove.stops", "#page_stops", function()
	{
		$( window ).off( ".stops" );
		$( document ).off(".stops");
		$( 'link[href="css/pageStops.css"]' ).remove();
		pageStops = null;
	});



