/* CSS */
$("body").append('<link rel="stylesheet" type="text/css" href="css/pageSuggestions.css"/>');

/* VARIABLES */
var pageSuggestions = {

    $page: null,
    subjectSelected: "",
    lineSelected: "",
    stopSelected: "",
    _attachedFileObject: {
        id: String,
        name: String,
        base64: String,
    },
    _attachedFiles: [],
    fileIndex: 0,

    init: function() {
        pageSuggestions.addContent();
        pageSuggestions.subjectSelected = functionsGlobals.getURLParameter("subject") || "";
        pageSuggestions.lineSelected = functionsGlobals.getURLParameter("line") || "";
        pageSuggestions.stopSelected = functionsGlobals.getURLParameter("stop") || "";
    },

    addContent: function() {
        pageSuggestions.$page.find("#page_title").text(gjson_lang['page_title_suggestions']);

        pageSuggestions.$page.find('#input-subject').html('<option value=""> ' + gjson_lang['suggestions_send_subject'] + ' *</option>');
        pageSuggestions.loadCommunicationTypes();

        pageSuggestions.$page.find('#input-line').html('<option value=""> ' + gjson_lang['suggestions_send_line'] + ' </option>');

        pageSuggestions.$page.find('#input-stop').html(gjson_lang['suggestions_send_stop']);

        pageSuggestions.$page.find('#input-email').attr('placeholder', gjson_lang['suggestions_send_email']);

        pageSuggestions.$page.find('#input-description').attr('placeholder', gjson_lang['suggestions_send_description'] + " *");

        if (!JSON.parse(localStorage.getItem("array_lineas"))) {
            if (checkConnection())
                CallServiceCAI(aConfig["gstr_webServiceURLCAI"], SoapgetLines(), "pageSuggestions.LoadLines");
            else
                functionsGlobals.showMessage(gjson_lang['connectionError'], "NO");
        } else pageSuggestions.showLines();

    },
    loadCommunicationTypes: function() {
        pageSuggestions.$page.find('#input-subject').append('<option value="1"> ' + gjson_lang['suggestions_type_query_complaint'] + ' </option>');
        pageSuggestions.$page.find('#input-subject').append('<option value="2"> ' + gjson_lang['suggestions_type_query_suggestion'] + ' </option>');
        pageSuggestions.$page.find('#input-subject').append('<option value="3"> ' + gjson_lang['suggestions_type_query_congratulation'] + ' </option>');
        pageSuggestions.$page.find('#input-subject').append('<option value="4"> ' + gjson_lang['suggestions_type_query_notice'] + ' </option>');
        pageSuggestions.$page.find('#input-subject').append('<option value="5"> ' + gjson_lang['suggestions_type_query_request'] + ' </option>');
        pageSuggestions.$page.find('#input-subject').append('<option value="7"> ' + gjson_lang['suggestions_type_query_report'] + ' </option>');
        pageSuggestions.$page.find('#input-subject').append('<option value="6"> ' + gjson_lang['suggestions_type_query_other'] + ' </option>');

        pageSuggestions.$page.find('#input-subject').selectmenu('refresh', true);
    },
    LoadLines: function(data) {

        var aLineas = [];
        $.each(data.featureMembers.Line, function(i, item) {
            if (item.routesForLine != undefined) {
                if (item.routesForLine[0].Route.direction.Direction.identity.DirectionCode.identifier == "IDA")
                    aLineas.push({
                        id_linea: item.identity.LineCode.identifier,
                        name_linea: item.lineName,
                        id_Route0: item.routesForLine[0].Route.identity.RouteCode.identifier,
                        id_Route1: item.routesForLine[1].Route.identity.RouteCode.identifier
                    });
                else
                    aLineas.push({
                        id_linea: item.identity.LineCode.identifier,
                        name_linea: item.lineName,
                        id_Route0: item.routesForLine[1].Route.identity.RouteCode.identifier,
                        id_Route1: item.routesForLine[0].Route.identity.RouteCode.identifier
                    });
            }
        });


        localStorage.setItem("array_lineas", JSON.stringify(aLineas));
        pageSuggestions.showLines();
    },
    showLines: function() {
        var aLineas = JSON.parse(localStorage.getItem("array_lineas"));


        $.each(aLineas, function(i, item) {
            pageSuggestions.$page.find("#input-line").append('<option value="' + item.id_linea + '">' + item.id_linea + " - " + item.name_linea + '</option>');
        });

        pageSuggestions.$page.find('#input-line').selectmenu('refresh', true);
        functionsGlobals.hideLoading();
    },
    validate: {
        isValidForm: function() {
            var validSubject = pageSuggestions.validate.isValidSelectMenu(pageSuggestions.$page.find('#input-subject'));
            var validDescription = pageSuggestions.validate.isValidText(pageSuggestions.$page.find('#input-description'));
            var validEmail = pageSuggestions.validate.isValidEmail(pageSuggestions.$page.find('#input-email'));

            return (validSubject && validDescription && validEmail);
        },
        isValidEmail: function(emailInput) {

            if (emailInput != undefined) {
                var email = emailInput.val();
                var re = /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
                if (re.test(String(email).toLowerCase())) {
                    emailInput.removeClass("red-border");
                    return true;
                } else {
                    emailInput.addClass("red-border");
                    return false;
                }

            } else {
                return true;
            }

           
        },
        isValidSelectMenu: function(selectmenu) {
            var selectbutton = $("#" + selectmenu.attr('id') + "-button");
            if (selectmenu.val() !== "") {
                selectbutton.removeClass("red-border");
                return true;
            } else {
                selectbutton.addClass("red-border");
                return false;
            }
        },
        isValidText: function(textInput) {
            if (textInput.val().length > 10) {
                textInput.removeClass("red-border");
                return true;
            } else {
                textInput.addClass("red-border");
                return false;
            }
        }
    },
    sendEmail: function(location) {
        var href_mail = "";

        functionsGlobals.showLoading();

        var subject = pageSuggestions.subjectSelected;
        var line = $('#input-line option:selected').text();
        var stop = $('#input-stop').text();
        var description = $('#input-description').val();
        var email = $('#input-email').val();
        // make taldeka request to API
        makeTaldekaRequest(subject, line, stop, description, email, pageSuggestions._attachedFiles);

    },
    getObservations: function() {
        var networkState = navigator.connection.type;
        var states = {};
        states[Connection.UNKNOWN] = 'Unknown';
        states[Connection.ETHERNET] = 'Ethernet';
        states[Connection.WIFI] = 'WiFi';
        states[Connection.CELL_2G] = '2G';
        states[Connection.CELL_3G] = '3G';
        states[Connection.CELL_4G] = '4G';
        states[Connection.CELL] = 'Cell generic';
        states[Connection.NONE] = 'No network';

        return device.platform + ' ' + device.version + ' | ' + states[networkState];
    },
    manage: {
        subjectSelection: function() {
            var subjectSelected = pageSuggestions.subjectSelected;
            pageSuggestions.$page.find('#input-subject').val(subjectSelected);
            pageSuggestions.$page.find('#input-subject').selectmenu('refresh', true);
        },
        lineSelection: function() {
            var lineSelected = pageSuggestions.lineSelected;
            pageSuggestions.$page.find('#input-line').val(lineSelected);
            pageSuggestions.$page.find('#input-line').selectmenu('refresh', true);
        },
        stopSelection: function() {
            var stopSelected = pageSuggestions.stopSelected;
            if (stopSelected !== "")
                pageSuggestions.$page.find('#input-stop').text(stopSelected);
            else
                pageSuggestions.$page.find('#input-stop').text(gjson_lang['suggestions_send_stop']);
        }
    },
    createURL: function() {
        var amb1 = "&";
        var amb2 = "&";

        var line = (pageSuggestions.lineSelected === "") ? "" : "line=" + pageSuggestions.lineSelected;
        var subject = (pageSuggestions.subjectSelected === "") ? "" : "subject=" + pageSuggestions.subjectSelected;
        var stop = (pageSuggestions.stopSelected === "") ? "" : "stop=" + pageSuggestions.stopSelected;

        if (line === "")
            amb1 = "";

        if (subject === "")
            amb2 = "";

        return "selectStop.html?" + line + amb1 + stop + amb2 + subject;
    }

};


function addToConvertFile(file) {

    // convert file
    var fileObject = {
        index: pageSuggestions.fileIndex,
        name: file.name,
        file: file.dataURI.split(',')[1],
        convertedbase64: file.dataURI.split(',')[1],
        fileUri: file.uri
    }

    pageSuggestions.fileIndex = parseInt(pageSuggestions.fileIndex + 1);
    console.warn("Add images");
    pageSuggestions._attachedFiles.push(fileObject);

    $('#getFile').hide();
    $('#getImage').hide();

    $('#attachedFileList').append("<div  id='div" + fileObject.index + "' class='imgRow' ><br/><span>" + fileObject.name + "</span><img class='deleteIcon' id='" + fileObject.index + "' src='./img/globals/header/ic_close_black.png'><br/></div>");
}

function getImageFile(file) {

    var fileObject = {
        index: pageSuggestions.fileIndex,
        name: 'image' + pageSuggestions.fileIndex + '.jpg',
        file: file,
        convertedbase64: 'data:image/png;base64,' + file,
        fileUri: 'file.uri'
    }

    pageSuggestions.fileIndex = parseInt(pageSuggestions.fileIndex + 1);
    pageSuggestions._attachedFiles.push(fileObject)
    $('#getFile').hide();
    $('#getImage').hide();
    $('#attachedFileList').append("<div  id='div" + fileObject.index + "' class='imgRow'><br/><span>" + fileObject.name + "</span><img class='deleteIcon' id='" + fileObject.index + "' src='./img/globals/header/ic_close_black.png'><br/></div>");

}

/* EVENTS */

$(document).off(".suggestions")

.on("pagecreate.suggestions", "#page_suggestions", function() {
    pageSuggestions.$page = $(this);
})

.on("pageshow.suggestions", "#page_suggestions", function() {
    pageSuggestions.init();
    pageSuggestions.manage.subjectSelection();
    pageSuggestions.manage.lineSelection();
    pageSuggestions.manage.stopSelection();
})

.on("click.suggestions", "#page_suggestions #suggestions_form_submit", function(event) {

       if (pageSuggestions.validate.isValidForm() && pageSuggestions.validate.isValidEmail())
       
        pageSuggestions.sendEmail();
    else
        alert(gjson_lang['complete_form']);
})

.on("mouseup.suggestions", "#page_suggestions #suggestions_form_submit", function(event) {
    $(this).removeClass("ui-btn-active");
    $("#page_suggestions #suggestions_form_submit").attr("href", "#");
})

.on("change.suggestions", "#page_suggestions #input-subject", function() {
    var subjectSelected = $(this).val();
    pageSuggestions.subjectSelected = subjectSelected;
    pageSuggestions.validate.isValidSelectMenu($(this));
})

.on("change.suggestions", "#page_suggestions #input-line", function() {
    var lineSelected = $(this).val();
    pageSuggestions.lineSelected = lineSelected;
})

.on("click.suggestions", "#page_suggestions #input-stop", function(event) {
    event.preventDefault();
    $("body").pagecontainer("change", pageSuggestions.createURL());
    return false;
})

.on("keyup.suggestions", "#page_suggestions #input-description", function() {
    pageSuggestions.validate.isValidText($(this));
})

.on("pageremove.suggestions", "#page_suggestions", function() {
    $(window).off(".suggestions");
    $(document).off(".suggestions");
    $('link[href="css/pageSuggestions.css"]').remove();
    pageSuggestions = null;
})


.on("click.suggestions", "#getFile ", function(event) {
    // add File

    var mimeTypes = 'application/pdf,application/msword,application/vnd.openxmlformats-officedocument.wordprocessingml.document,image/png,image/jpg,image/jpeg';
    (async() => {
        const file = await chooser.getFile(mimeTypes);

        if (file) {
            addToConvertFile(file);
        }
    })();
})

.on("click.suggestions", "#getImage ", function(event) {
    // add image file

    options = {
        maximumImagesCount: 1,
        width: 500,
        height: 500,
        quality: 100,
        outputType: 1
    };

    window.imagePicker.getPictures(
        function(results) {
            for (let i = 0; i < results.length; i++) {
                if (results.length > 0) {
                    getImageFile(results[0]);
                }
            }
        },
        function(error) {
            console.log('Error: ' + error);
        }, options
    );

})

.on("click.suggestions", ".imgRow", function(event) {

    // remove from array and view
    var imgId = event.target.id;
    $("#div" + imgId).remove();

    for (var i = 0; i < pageSuggestions._attachedFiles.length; i++) {
        if (pageSuggestions._attachedFiles[i].index == imgId) {
            pageSuggestions._attachedFiles.splice([i], 1)
        }
    }
    if (pageSuggestions._attachedFiles.length == 0) {
        pageSuggestions.fileIndex = parseInt('0');

        $('#getFile').show();
        $('#getImage').show();
    }
})