/* CSS */
$("body").append('<link rel="stylesheet" type="text/css" href="css/pageTravelMap.css"/>');

/* VARIABLES */
var pageTravelMap = {

    $page: null,
    $view: null,
    $uPoint: null,
    $timeout: null,

    init: function() {
        functionsGlobals.showLoading();
        var direction = sessionStorage.getItem("direction");
        pageTravelMap.$page.find("#page_title").text(sessionStorage.getItem("codigoLineaActiva") + " - " + sessionStorage.getItem("name_linea" + direction));

        if (!localStorage.getItem("array_paradas")) {
            sessionStorage.setItem("activeFunction", "pageTravelMap.init()");
            CallServiceCAI(aConfig["gstr_webServiceURLCAI"], createSoapRequestgetStops(), "functionsGlobals.saveStops");
        } else {
            pageTravelMap.addContent();
            $(".div_map_travel").css("top", $(".ui-header").height());
        }
    },

    addContent: function() {
        lat = sessionStorage.getItem("latitud");
        lng = sessionStorage.getItem("longitud");

        pageTravelMap.createPoints();
    },

    createPoints: function() {
        $uPoint = ol.proj.fromLonLat([eval(lng), eval(lat)]);

        var userLayer = functionsGlobals.createOpenLayerPoint($uPoint, aConfig["gobl_icon_user"], ".6", null);

        pageTravelMap.$page.find("#map-canvas-travel-map").empty();

        $view = new ol.View({
            center: $uPoint,
            zoom: 15
        });


        fetch('https://www.geobilbao.eus/geobilbao/Main?gsservice=ls&gsrequest=wmts&idservice=WMTS_Geobilbao').then(function(response) {
            return response.text();
        }).then(function(text) {


            var parser = new ol.format.WMTSCapabilities();
            var result = parser.read(text);

            var options = ol.source.WMTS.optionsFromCapabilities(result, {
                layer: 'Urb_cartografia:Cartografia_10000_Web'
            });


            var source = new ol.source.WMTS( /** @type {!module:ol/source/WMTS~Options} */ (options));

            source.on('tileloaderror', function(event) {
                pageTravelMap.tileLoadingError()

            });


            pageTravelMap.$map = new ol.Map({
                target: 'map-canvas-travel-map',
                layers: [
                    new ol.layer.Tile({
                        opacity: 1,
                        minResolution: 0,
                        maxResolution: 14,
                        source: source
                    }),

                    new ol.layer.Tile({
                        preload: Infinity,
                        minResolution: 14,
                        maxResolution: 1000,
                        source: new ol.source.OSM({
                            "url": "https://cartodb-basemaps-a.global.ssl.fastly.net/light_all/{z}/{x}/{y}.png",
                        })
                    }),
                ],

                loadTilesWhileAnimating: true,
                view: $view,

            });

        });

        if (sessionStorage.getItem("sentido") == 1)
            var sentidoLinea = "IDA";
        else
            var sentidoLinea = "VLT";


        setTimeout(function() {
            pageTravelMap.$map.addLayer(userLayer);
            pageTravelMap.$map.updateSize();
            functionsGlobals.getRutaOL(sessionStorage.getItem("codigoLineaActiva"), sentidoLinea, "pageTravelMap.$map");
            functionsGlobals.getBusOL(sessionStorage.getItem("codigoLineaActiva"), sentidoLinea, "pageTravelMap.$map");
            functionsGlobals.getBusStopOL(sessionStorage.getItem("codigoLineaActiva"), sentidoLinea, "pageTravelMap.$map");

        }, 2000);


        functionsGlobals.hideLoading();
    },


    changeDirection: function() {

        if (sessionStorage.getItem("direction") == sessionStorage.getItem("filter1")) {
            sessionStorage.setItem("direction", sessionStorage.getItem("filter2"));
            sessionStorage.setItem("sentido", "2");
        } else {
            sessionStorage.setItem("direction", sessionStorage.getItem("filter1"));
            sessionStorage.setItem("sentido", "1");
        }

        var direction = sessionStorage.getItem("direction");
        pageTravelMap.$page.find("#page_title").text(sessionStorage.getItem("codigoLineaActiva") + " - " + sessionStorage.getItem("name_linea" + direction));
        pageTravelMap.createPoints();

    },

    tileLoadingError() {
        // functionsGlobals.showMessage("error de capas");
        // // pageTravelMap.$page.find("#map-canvas-travel-map").hide();

        // setTimeout(function() {
        //    location.reload();
        // }, 3000);



        // if (pageTravelMap.$timeout == null) {
        //     pageTravelMap.$timeout = setTimeout(function() {
        //         $view.setZoom(15);
        //         pageTravelMap.$timeout = null
        //     }, 3000);
        // }



    },



};

/* EVENTS */

$(document).off(".travelMap")

.on("pagecreate.travelMap", "#page_travel_map", function() {
    pageTravelMap.$page = $(this);
})

.on("pagebeforeshow.travelMap", "#page_travel_map", function() {
    functionsGlobals.getLocation();
    projSourceCG = new Proj4js.Proj("EPSG:23030");
    projDestCG = new Proj4js.Proj("EPSG:4326");
    projDestGC = new Proj4js.Proj("EPSG:23030");
})

.on("pageshow.travelMap", "#page_travel_map", function() {
    pageTravelMap.init();
})

.on("click.travelMap", "#page_travel_map #changeDirection", function(event) {
    event.preventDefault();
    pageTravelMap.changeDirection();
    return false;
})

.on("click.travelMap", "#page_travel_map .footer_links", function(event) {
    event.preventDefault();
    if ($(this).attr("id") == 'footer_stops') $("body").pagecontainer("change", "stops.html?filter=" + sessionStorage.getItem("filter1") + "&filter2=" + sessionStorage.getItem("filter2"));
    if ($(this).attr("id") == 'footer_route') $("body").pagecontainer("change", "travelMap.html?id=" + sessionStorage.getItem("direction") + "&name=" + sessionStorage.getItem("name_linea" + sessionStorage.getItem("direction")));
    if ($(this).attr("id") == 'footer_schedule') $("body").pagecontainer("change", "schedule.html?filter=" + sessionStorage.getItem("filter1") + "&filter2=" + sessionStorage.getItem("filter2"));
    if ($(this).attr("id") == 'footer_lineNews') $("body").pagecontainer("change", "lineNews.html");
    return false;
})

.on("click.travelMap", "#page_travel_map #back_btn_travel", function(event) {
    event.preventDefault();

    if (sessionStorage.getItem("actual_StopTimes") && sessionStorage.getItem("back_complete"))
        window.history.back();
    else if (sessionStorage.getItem("back_favorite"))
        $("body").pagecontainer("change", "favorites_lineas.html");
    else
        $("body").pagecontainer("change", "lines.html");

    return false;
})

.on("pageremove.travelMap", "#page_travel_map", function() {
    $(window).off(".travelMap");
    $(document).off(".travelMap");
    $('link[href="css/pageTravelMap.css"]').remove();
    $(this).remove();
    pageTravelMap = null;
});