var ACCESS_TOKEN = null;


var _subject, _line, _stop, _description, _email, _languageId = null;
var _attachedFiles = [];

var errorCounter = 0;



function CallService(webServiceURL, soapRequest, theFunction) {

    $.ajax({
        url: webServiceURL,
        timeout: aConfig["timeout_WS"], // 60 secs for kicks
        type: "POST",
        dataType: "xml",
        cache: false,
        data: soapRequest,
        headers: { soapAction: aConfig["gstr_webServiceURL"] },
        contentType: "text/xml; charset=\"utf-8\"",
        success: function(response) {
            var data = $.xml2json($(response).text());
            eval(theFunction)(data);
        },
        error: function(msg) {
            console.log(msg);
            functionsGlobals.hideLoading();
            functionsGlobals.showMessage(gjson_lang['error_ajax']);
        },
    });
}

function CallServiceCAI(webServiceURL, soapRequest, theFunction) {
    $.ajax({
        url: webServiceURL,
        timeout: aConfig["timeout_WS"], // 60 secs for kicks
        type: "POST",
        dataType: "xml",
        data: soapRequest,
        cache: false,
        headers: { soapAction: aConfig["gstr_webServiceURLCAI"] },
        contentType: "text/xml; charset=\"utf-8\"",
        success: function(response) {
            var data = $.xml2json(response);
            eval(theFunction)(data);
        },
        error: function(msg, response) {
            console.log(msg);
            if ($.mobile.activePage.is(".StopStimes"))
                $("#stopTimes_content").hide();
            functionsGlobals.hideLoading();
            functionsGlobals.showMessage(gjson_lang['error_ajax']);
        },
    });
}

function createSoapRequestGetLineInfo(codigoLinea) {

    Str_xml_call = '<Envelope xmlns="http://schemas.xmlsoap.org/soap/envelope/"> \
                <Body> \
                    <wsBilbao xmlns="https://www.bilbao.eus/ws_bilbao/"> \
                        <servicio>BUSLISTLIN</servicio> \
                        <usuario>BILBOBUS</usuario>' +
        '<parametros><![CDATA[<?xml version="1.0" encoding="UTF-8"?> \
                            <PETICION> \
                                <CODIGOLINEA>' + codigoLinea + '</CODIGOLINEA> \
                            </PETICION> \
                        ]]></parametros> \
                    </wsBilbao> \
                </Body> \
            </Envelope>';
    return Str_xml_call;
}

function createSoapRequestGetLineColors(codigoLinea) {
    Str_xml_call = '<Envelope xmlns="http://schemas.xmlsoap.org/soap/envelope/"> \
                <Body> \
                    <wsBilbao xmlns="https://www.bilbao.eus/ws_bilbao/"> \
                        <servicio>BUSLISTLIN</servicio> \
                        <usuario>BILBOBUS</usuario>' +
        '<parametros><![CDATA[<?xml version="1.0" encoding="UTF-8"?> \
                            <PETICION> \
                            </PETICION> \
                        ]]></parametros> \
                    </wsBilbao> \
                </Body> \
            </Envelope>';
    return Str_xml_call;
}

function createSoapRequestgetStopsPerLine(codigoLinea) {
    Str_xml_call = '<Envelope xmlns="http://schemas.xmlsoap.org/soap/envelope/"> \
                <Body> \
                    <wsBilbao xmlns="https://www.bilbao.eus/ws_bilbao/"> \
                        <servicio>BUSLISTPAR</servicio> \
                        <usuario>BILBOBUS</usuario>' +
        '<parametros><![CDATA[<?xml version="1.0" encoding="UTF-8"?> \
                            <PETICION> \
                                <CODIGOLINEA>' + codigoLinea + '</CODIGOLINEA> \
                            </PETICION> \
                        ]]></parametros> \
                    </wsBilbao> \
                </Body> \
            </Envelope>';
    return Str_xml_call;
}


function createSoapRequestgetStops() {
    Str_xml_call = '<wfs:GetFeature xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" \
                        xsi:schemaLocation="http://www.opengis.net/wfshttp://schemas.opengis.net/wfs/1.1.0/wfs.xsd" \
                        xmlns:gml="http://www.opengis.net/gml" xmlns:wfs="http://www.opengis.net/wfs" \
                        xmlns:ept="http://namespace.emotion-project.eu/version/Final2.1.0/pubtrans" \
                        xmlns:ogc="http://www.opengis.net/ogc" service="WFS" version="1.1.0" outputFormat="GML3"> \
                        <wfs:Query typeName="ept:StopPoint"> \
                        </wfs:Query> \
                    </wfs:GetFeature> ';
    return Str_xml_call;
}




function createSoapRequestgetStopsNearMap(lng1, lat1, lng2, lat2) {
    Str_xml_call = '<wfs:GetFeature xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" \
                        xsi:schemaLocation="http://www.opengis.net/wfshttp://schemas.opengis.net/wfs/1.1.0/wfs.xsd" \
                        xmlns:gml="http://www.opengis.net/gml" xmlns:wfs="http://www.opengis.net/wfs" \
                        xmlns:ept="http://namespace.emotion-project.eu/version/Final2.1.0/pubtrans" \
                        xmlns:ogc="http://www.opengis.net/ogc" service="WFS" version="1.1.0" outputFormat="GML3"> \
                        <wfs:Query typeName="ept:StopPoint"> \
                            <ogc:Filter> \
                                <ogc:Intersects> \
                                <ogc:PropertyName>ept:StopPoint/ept:projection/elr:PointGeometry/elr:geometry</ogc:PropertyName> \
                                <gml:Envelope srsName="http://www.opengis.net/gml/srs/epsg.xml#4326"> \
                                   <gml:lowerCorner>' + lng2 + '  ' + lat2 + '</gml:lowerCorner> \
                                   <gml:upperCorner>' + lng1 + '  ' + lat1 + '</gml:upperCorner> \
                                </gml:Envelope> \
                             </ogc:Intersects> \
                          </ogc:Filter> \
                        </wfs:Query> \
                    </wfs:GetFeature> ';
    return Str_xml_call;
}

function SoapgetLines() {
    Str_xml_call = '<wfs:GetFeature xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" \
                        xsi:schemaLocation="http://www.opengis.net/wfs http://schemas.opengis.net/wfs/1.1.0/wfs.xsd" \
                        xmlns:gml="http://www.opengis.net/gml" xmlns:wfs="http://www.opengis.net/wfs" \
                        xmlns:ept="http://namespace.emotion-project.eu/version/Final2.1.0/pubtrans" \
                        xmlns:ogc="http://www.opengis.net/ogc" service="WFS" version="1.1.0" > \
                        <wfs:Query typeName="ept:Line"> \
                        </wfs:Query> \
                        </wfs:GetFeature>';
    return Str_xml_call;
}

function createSoapRequesgetEstimatedCall(filter) {
    Str_xml_call = '<wfs:GetFeature xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" \
                        xsi:schemaLocation="http://www.opengis.net/wfs http://schemas.opengis.net/wfs/1.1.0/wfs.xsd" \
                        xmlns:gml="http://www.opengis.net/gml" xmlns:wfs="http://www.opengis.net/wfs" \
                        xmlns:ept="http://namespace.emotion-project.eu/version/Final2.1.0/pubtrans" \
                        xmlns:ogc="http://www.opengis.net/ogc" service="WFS" version="1.1.0" > \
                        version="1.1.0"> \
                          <wfs:Query typeName="ept:EstimatedCall"> \
                            <ogc:Filter> \
                              <ogc:PropertyIsEqualTo> \
                                <ogc:PropertyName>ept:EstimatedCall/ept:isStopPointInSequence/ept:StopPointInSequence/ept:stopPointRef/ept:StopPointCode/ept:identifier</ogc:PropertyName> \
                                <ogc:Literal>' + filter + '</ogc:Literal> \
                              </ogc:PropertyIsEqualTo> \
                            </ogc:Filter> \
                          </wfs:Query> \
                        </wfs:GetFeature>';
    return Str_xml_call;
}

function createSoapRequestGetPattern(filter) {
    /*Str_xml_call = '<wfs:GetFeature xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" \
                    xsi:schemaLocation="http://www.opengis.net/wfs http://schemas.opengis.net/wfs/1.1.0/wfs.xsd" \
                    xmlns:gml="http://www.opengis.net/gml" xmlns:wfs="http://www.opengis.net/wfs" \
                    xmlns:ept="http://namespace.emotion-project.eu/version/Final2.1.0/pubtrans" \
                    xmlns:ogc="http://www.opengis.net/ogc" service="WFS" version="1.1.0" > \
                    version="1.1.0"> \
                      <wfs:Query typeName="ept:JourneyPattern"> \
                        <ogc:Filter> \
                          <ogc:PropertyIsEqualTo> \
                            <ogc:PropertyName>ept:JourneyPattern/ept:routeForJourneyPattern/ept:Route/ept:identity/ept:RouteCode/ept:identifier</ogc:PropertyName> \
                            <ogc:Literal>'+filter+'</ogc:Literal> \
                          </ogc:PropertyIsEqualTo> \
                        </ogc:Filter> \
                      </wfs:Query> \
                    </wfs:GetFeature>';*/

    Str_xml_call = '<wfs:GetFeature xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" \
                        xsi:schemaLocation="http://www.opengis.net/wfs http://schemas.opengis.net/wfs/1.1.0/wfs.xsd" \
                        xmlns:gml="http://www.opengis.net/gml" xmlns:wfs="http://www.opengis.net/wfs" \
                        xmlns:ept="http://namespace.emotion-project.eu/version/Final2.1.0/pubtrans" \
                        xmlns:ogc="http://www.opengis.net/ogc" service="WFS" version="1.1.0" > \
                        version="1.1.0"> \
                            <wfs:Query typeName="ept:ServicePattern"> \
                                <ogc:Filter> \
                                    <ogc:PropertyIsEqualTo> \
                                        <ogc:PropertyName>ept:ServicePattern/ept:routeForServicePattern/ept:Route/ept:identity/ept:RouteCode/ept:identifier</ogc:PropertyName> \
                                        <ogc:Literal>' + filter + '</ogc:Literal> \
                                    </ogc:PropertyIsEqualTo> \
                                </ogc:Filter> \
                              </wfs:Query> \
                            </wfs:GetFeature>';
    return Str_xml_call;
}


function createSoapRequestGetPattern2(filter) {
    Str_xml_call = '<wfs:GetFeature xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" \
                        xsi:schemaLocation="http://www.opengis.net/wfs http://schemas.opengis.net/wfs/1.1.0/wfs.xsd" \
                        xmlns:gml="http://www.opengis.net/gml" xmlns:wfs="http://www.opengis.net/wfs" \
                        xmlns:ept="http://namespace.emotion-project.eu/version/Final2.1.0/pubtrans" \
                        xmlns:ogc="http://www.opengis.net/ogc" service="WFS" version="1.1.0" > \
                        version="1.1.0"> \
                          <wfs:Query typeName="ept:JourneyPattern"> \
                            <ogc:Filter> \
                              <ogc:PropertyIsEqualTo> \
                                <ogc:PropertyName>ept:JourneyPattern/ept:routeForJourneyPattern/ept:Route/ept:identity/ept:RouteCode/ept:identifier</ogc:PropertyName> \
                                <ogc:Literal>' + filter + '</ogc:Literal> \
                              </ogc:PropertyIsEqualTo> \
                            </ogc:Filter> \
                          </wfs:Query> \
                        </wfs:GetFeature>';

    return Str_xml_call;
}

function createSoapRequestGetStopsInfo(filter) {
    Str_xml_call = '<wfs:GetFeature xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" \
                        xsi:schemaLocation="http://www.opengis.net/wfs http://schemas.opengis.net/wfs/1.1.0/wfs.xsd" \
                        xmlns:gml="http://www.opengis.net/gml" xmlns:wfs="http://www.opengis.net/wfs" \
                        xmlns:ept="http://namespace.emotion-project.eu/version/Final2.1.0/pubtrans" \
                        xmlns:ogc="http://www.opengis.net/ogc" service="WFS" version="1.1.0" > \
                          <wfs:Query typeName="ept:StopPoint"> \
                            <ogc:Filter> \
                              <ogc:PropertyIsEqualTo> \
                                <ogc:PropertyName>ept:StopPoint/gml:id</ogc:PropertyName> \
                                <ogc:Literal>' + filter + '</ogc:Literal> \
                              </ogc:PropertyIsEqualTo> \
                            </ogc:Filter> \
                          </wfs:Query> \
                        </wfs:GetFeature>';
    return Str_xml_call;
}


// taldeka API

function makeTaldekaRequest(subject, line, stop, description, email, attachedFiles) {

    _subject = subject;
    _line = line;
    _stop = stop;
    _description = description;
    _email = email;
    console.error(attachedFiles);

    _attachedFiles = attachedFiles;

    var canalRespuesta = "";

    checkLanguageId();

    getAuthorizationToken();
}


function getTaldekaIdFromLineCode() {

    var lineID = _line.slice(0, 2);

    var lineCode;

    console.warn(lineID);

    switch (lineID) {

        case '01':
            lineCode = 112;
            break;

        case '03':
            lineCode = 113;
            break;

        case '10':
            lineCode = 114;
            break;

        case '11':
            lineCode = 115;
            break;

        case '13':
            lineCode = 116;
            break;

        case '18':
            lineCode = 117;
            break;

        case '22':
            lineCode = 118;
            break;

        case '27':
            lineCode = 119;
            break;

        case '28':
            lineCode = 120;
            break;

        case '30':
            lineCode = 121;
            break;

        case '34':
            lineCode = 122;
            break;

        case '38':
            lineCode = 123;
            break;

        case '40':
            lineCode = 124;
            break;

        case '43':
            lineCode = 125;
            break;

        case '48':
            lineCode = 126;
            break;

        case '50':
            lineCode = 127;
            break;

        case '56':
            lineCode = 128;
            break;

        case '57':
            lineCode = 129;
            break;

        case '58':
            lineCode = 130;
            break;

        case '62':
            lineCode = 131;
            break;

        case '71':
            lineCode = 132;
            break;

        case '72':
            lineCode = 133;
            break;

        case '75':
            lineCode = 134;
            break;

        case '76':
            lineCode = 135;
            break;

        case '77':
            lineCode = 136;
            break;

        case '85':
            lineCode = 137;
            break;

        case '88':
            lineCode = 138;
            break;

        case 'A1':
            lineCode = 139;
            break;

        case 'A2':
            lineCode = 140;
            break;

        case 'A3':
            lineCode = 141;
            break;

        case 'A4':
            lineCode = 142;
            break;

        case 'A5':
            lineCode = 143;
            break;

        case 'A6':
            lineCode = 144;
            break;

        case 'A7':
            lineCode = 145;
            break;

        case 'A8':
            lineCode = 146;
            break;

        case 'G1':
            lineCode = 147;
            break;

        case 'G2':
            lineCode = 148;
            break;

        case 'G3':
            lineCode = 149;
            break;

        case 'G4':
            lineCode = 150;
            break;

        case 'G5':
            lineCode = 151;
            break;

        case 'G6':
            lineCode = 152;
            break;

        case 'G7':
            lineCode = 153;
            break;

        case 'G8':
            lineCode = 154;
            break;

        case 'E5':
            lineCode = 156;
            break;

        case 'E6':
            lineCode = 157;
            break;

        case 'E7':
            lineCode = 158;
            break;

        default:
            lineCode = 0;
    }

    return lineCode;

}

function taldekaAPIRequest() {

    console.log("Taldeka API Request");
    console.log(errorCounter);

    filesArray = "";

    // function cañonazo
    // Cañonazo
    // 1 primero itento con 2 ==
    // 2 intento con 1 =
    // 3 intento sin =


    // UR saber que archivo esta fallando para cambiar los '==' de solo ese archivo
    //saber el indice del archivo

        console.warn(_attachedFiles);

    // console.warn(_attachedFiles.indexOf('image0.jpg'));




    if (_attachedFiles.length > 0) {
        filesArray = "<![CDATA[ <ARCHIVOS>";
        // prepare Files to make Request
        console.error(_attachedFiles);
        for (var i = 0; i < _attachedFiles.length; i++) {

            if (errorCounter === 0) {
                filesArray = filesArray + "<ARCHIVO><fichero>" + _attachedFiles[i].name + "</fichero><titulo>" + _attachedFiles[i].name + "</titulo> <base64>" + _attachedFiles[i].file + "==</base64></ARCHIVO>"
            } else if (errorCounter === 1) {
                filesArray = filesArray + "<ARCHIVO><fichero>" + _attachedFiles[i].name + "</fichero><titulo>" + _attachedFiles[i].name + "</titulo> <base64>" + _attachedFiles[i].file + "=</base64></ARCHIVO>"
            } else if (errorCounter === 2) {
                filesArray = filesArray + "<ARCHIVO><fichero>" + _attachedFiles[i].name + "</fichero><titulo>" + _attachedFiles[i].name + "</titulo> <base64>" + _attachedFiles[i].file + "</base64></ARCHIVO>"
            } else {
                filesArray = filesArray + "<ARCHIVO><fichero>" + _attachedFiles[i].name + "</fichero><titulo>" + _attachedFiles[i].name + "</titulo> <base64>" + _attachedFiles[i].file + "==</base64></ARCHIVO>"
            }


        }
        filesArray = filesArray + "</ARCHIVOS>]]>";
        console.warn(filesArray);
    }

    var lineCode = getTaldekaIdFromLineCode();

    if (lineCode == 0) {
        lineCode = "";
    }

    console.warn(lineCode);

    var canalRespuesta = "";

    console.warn(_email);

    if (_email != "") {
        canalRespuesta = 1;
    }

    console.error(canalRespuesta);

    if (_stop == "Parada" || _stop == "Geralekua" || _stop == "Stop") {
        console.warn("sin parada asignada");
        _stop = "";
    }


    // PD: Si envias el IDParada tienes que enviar el IDLinea

    $.ajax({
            async: true,
            crossDomain: true,
            url: aConfig["TALDEKA_WS_ENDPOINT"],
            method: "POST",
            headers: {
                "Authorization": "Bearer " + ACCESS_TOKEN,
                "Content-Type": "text/xml;charset=utf-8",
            },
            data: '<x:Envelope xmlns:x=\"http://schemas.xmlsoap.org/soap/envelope/" xmlns:tem=\"http://tempuri.org/">\
             <x:Header/>\
                <x:Body>\
                    <tem:NuevoRegistroQS>\
                        <tem:codigoAreaTema>T20</tem:codigoAreaTema>\
                        <tem:registrante>webservicebilbobus</tem:registrante>\
                        <tem:motivo>' + _description + '</tem:motivo>\
                        <tem:idTipoConsulta>' + _subject + '</tem:idTipoConsulta>\
                        <tem:idCanalEntrada>18</tem:idCanalEntrada>\
                        <tem:dniCiudadano></tem:dniCiudadano>\
                        <tem:idsexoCiudadano></tem:idsexoCiudadano>\
                        <tem:idLocalizacion>' + lineCode + '</tem:idLocalizacion>\
                        <tem:lugarEmplazamiento>' + _stop + '</tem:lugarEmplazamiento>\
                        <tem:idPoblacionCiudadano></tem:idPoblacionCiudadano>\
                         <tem:idProvinciaCiudadano></tem:idProvinciaCiudadano>\
                         <tem:idPaisCiudadano></tem:idPaisCiudadano>\
                         <tem:EmailCiudadano>' + _email + '</tem:EmailCiudadano>\
                         <tem:idCanalRespuesta>' + canalRespuesta + '</tem:idCanalRespuesta>\
                         <tem:idIdioma>' + _languageId + '</tem:idIdioma>\
                         <tem:Observaciones></tem:Observaciones>\
                         <tem:NRegistro></tem:NRegistro>\
                         <tem:xmlAdjuntos>' + filesArray + '</tem:xmlAdjuntos>\
                         <tem:CodigoRegistro></tem:CodigoRegistro>\
                         <tem:NExpediente></tem:NExpediente>\
                         <tem:idCalle></tem:idCalle>\
                         <tem:idCalleCiudadano></tem:idCalleCiudadano>\
                         </tem:NuevoRegistroQS>\
                    </x:Body>\
                    </x:Envelope>',

            success: function(response) {

                var data = $.xml2json(response);
                console.warn(data);

                if (data.Body.NuevoRegistroQSResponse.NuevoRegistroQSResult.PETICION.Estado == "OK") {
                    taldekaApiRequestSuccess(response);
                } else if (data.Body.NuevoRegistroQSResponse.NuevoRegistroQSResult.PETICION.ERRORES.ERROR.CodigoError == "32") {
                    console.warn("format base64 error");
                    taldekaApiBase64Error(response);

                } else if (data.Body.NuevoRegistroQSResponse.NuevoRegistroQSResult.PETICION.ERRORES != "") {
                    taldekaApiRequestError(response);
                }
            }
        }).done(function(response) {

            console.warn("done")

            console.log(response);
        })
        .error(function(err) {
            console.error(err)
            functionsGlobals.hideLoading();

            taldekaApiRequestError(err);

        });
}


function getAuthorizationToken(callback) {

    $.ajax({
        async: true,
        crossDomain: true,
        url: aConfig['TALDEKA_GET_AUTH_TOKEN'],
        method: "POST",
        headers: {
            "Content-Type": "application/x-www-form-urlencoded"
        },
        data: {
            'username': aConfig['TALDEKA_USERNAME'],
            'password': aConfig['TALDEKA_PWD'],
            'grant_type': aConfig['TALDEKA_GRANT_TYPE'],
            'client_id': aConfig['CLIENT_ID'],
            'client_secret': aConfig['CLIENT_SECRET']
        },

        success: function(response) {
            if (response.access_token != '') {
                ACCESS_TOKEN = response.access_token;
                taldekaAPIRequest();
            } else {
                getTokenError();
            }
        },
        error: function(err) {
            console.error(err);
            getTokenError();
        },
    })
}

function checkLanguageId() {

    //controlar ingles
    actualLang = localStorage.getItem('language');

    if (actualLang.toLowerCase() == 'es') {
        _languageId = 1;
    } else if(actualLang.toLowerCase() == 'eu') {
        _languageId = 2;
    } else if(actualLang.toLowerCase() == 'es'){
        _languageId = 3;
    }
}

function getTokenError() {
    console.error("ERROR al obtener el token");
    functionsGlobals.hideLoading();
    functionsGlobals.showMessage(gjson_lang['error_ajax']);

}

function taldekaApiRequestError(response) {
    console.error("ERROR al realizar la peticion a la API");
    functionsGlobals.hideLoading();
    functionsGlobals.showMessage(gjson_lang['error_ajax']);
}


function taldekaApiBase64Error(response) {
    console.error("ERROR el archivo en base64 esta corrupto");
    console.warn(errorCounter);

    console.warn(response);



    if (errorCounter <= 2) {
        errorCounter++;
        taldekaAPIRequest();
    }
}

function taldekaApiRequestSuccess(success) {
    errorCounter = 0;
    console.error(success);

    functionsGlobals.showMessage(gjson_lang['apiRequestSuccess'],"");
    // functionsGlobals.showMessage("Suggerencia enviada correctamente", "algo");

    document.location.href = "lines.html";

    // mensaje de enviado correctamente
    //volver al menu o enviar otra
}